// To use TMS Cryptography Pack in Win64, copy RandomDLL.dll from Win64 directory
// into C:\Windows\SysWOW64 if you are running 32 bit Windows
// or into C:\Windows\System32 if you are running 64 bit Windows

unit uCryptoDemo;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Diagnostics, System.DateUtils, System.UITypes, Vcl.FileCtrl,
  System.Classes, Vcl.Graphics, System.TimeSpan, System.IOUtils,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Imaging.pngimage, Vcl.ExtCtrls,
  Vcl.Buttons, Vcl.StdCtrls, Vcl.ComCtrls, AnsiStrings, Shellapi,
  AESObj, RSAObj, ECCObj, HashObj, SalsaObj, SPECKObj, MiscObj, X509Obj,
  XadesObj, CAdESObj, PAdESObj, AdESObj, PKCS11Obj,
  TMSEncryptedIniFile, CryptBase, tlsh;

type
  TForm5 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Label5: TLabel;
    Label6: TLabel;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    Image2: TImage;
    Panel2: TPanel;
    Image1: TImage;
    Label7: TLabel;
    Label8: TLabel;
    Panel3: TPanel;
    Image3: TImage;
    Label9: TLabel;
    Panel4: TPanel;
    Image4: TImage;
    Label10: TLabel;
    OpenDialog1: TOpenDialog;
    Label12: TLabel;
    Label13: TLabel;
    Edit3: TEdit;
    SpeedButton2: TSpeedButton;
    Panel5: TPanel;
    Image5: TImage;
    TabSheet2: TTabSheet;
    GroupBox4: TGroupBox;
    Label11: TLabel;
    Edit4: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    Edit5: TEdit;
    Label16: TLabel;
    Edit6: TEdit;
    GroupBox5: TGroupBox;
    Label17: TLabel;
    Label18: TLabel;
    Memo3: TMemo;
    Memo4: TMemo;
    Panel6: TPanel;
    Image6: TImage;
    Label19: TLabel;
    Panel7: TPanel;
    Image7: TImage;
    Label20: TLabel;
    GroupBox6: TGroupBox;
    Label21: TLabel;
    Label22: TLabel;
    Memo5: TMemo;
    Memo6: TMemo;
    Panel8: TPanel;
    Label23: TLabel;
    Panel9: TPanel;
    Label24: TLabel;
    Image8: TImage;
    Image9: TImage;
    Image10: TImage;
    Panel10: TPanel;
    TabSheet3: TTabSheet;
    GroupBox7: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    Label28: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Panel11: TPanel;
    Image11: TImage;
    GroupBox8: TGroupBox;
    Label29: TLabel;
    Label30: TLabel;
    Memo7: TMemo;
    Memo8: TMemo;
    Panel12: TPanel;
    Image12: TImage;
    Label31: TLabel;
    Panel13: TPanel;
    Image13: TImage;
    Label32: TLabel;
    GroupBox9: TGroupBox;
    Label33: TLabel;
    Label34: TLabel;
    Memo9: TMemo;
    Memo10: TMemo;
    Panel14: TPanel;
    Label35: TLabel;
    Image14: TImage;
    Panel15: TPanel;
    Label36: TLabel;
    Image15: TImage;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    TabSheet4: TTabSheet;
    GroupBox10: TGroupBox;
    Label27: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    Panel16: TPanel;
    Image16: TImage;
    Edit9: TEdit;
    GroupBox11: TGroupBox;
    Label40: TLabel;
    Label41: TLabel;
    Memo11: TMemo;
    Memo12: TMemo;
    Panel17: TPanel;
    Image17: TImage;
    Label42: TLabel;
    Panel18: TPanel;
    Image18: TImage;
    Label43: TLabel;
    GroupBox12: TGroupBox;
    SpeedButton3: TSpeedButton;
    Label44: TLabel;
    Label45: TLabel;
    SpeedButton4: TSpeedButton;
    Edit10: TEdit;
    Panel19: TPanel;
    Image19: TImage;
    Label46: TLabel;
    Panel20: TPanel;
    Image20: TImage;
    Label47: TLabel;
    Edit11: TEdit;
    TabSheet5: TTabSheet;
    GroupBox13: TGroupBox;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    ComboBox8: TComboBox;
    Panel21: TPanel;
    Image21: TImage;
    Edit12: TEdit;
    GroupBox14: TGroupBox;
    Label52: TLabel;
    Label53: TLabel;
    Memo13: TMemo;
    Memo14: TMemo;
    Panel22: TPanel;
    Image22: TImage;
    Label54: TLabel;
    Panel23: TPanel;
    Image23: TImage;
    Label55: TLabel;
    TabSheet6: TTabSheet;
    GroupBox15: TGroupBox;
    Label56: TLabel;
    ComboBox9: TComboBox;
    GroupBox16: TGroupBox;
    Label59: TLabel;
    Label60: TLabel;
    Memo15: TMemo;
    Memo16: TMemo;
    Panel26: TPanel;
    Image26: TImage;
    Label62: TLabel;
    GroupBox17: TGroupBox;
    SpeedButton5: TSpeedButton;
    Label63: TLabel;
    Edit14: TEdit;
    Panel27: TPanel;
    Image27: TImage;
    Label65: TLabel;
    Memo17: TMemo;
    Label48: TLabel;
    TabSheet7: TTabSheet;
    GroupBox18: TGroupBox;
    Label57: TLabel;
    ComboBox7: TComboBox;
    GroupBox19: TGroupBox;
    Label58: TLabel;
    Label61: TLabel;
    Memo18: TMemo;
    Memo19: TMemo;
    Panel24: TPanel;
    Image24: TImage;
    Label64: TLabel;
    GroupBox20: TGroupBox;
    SpeedButton6: TSpeedButton;
    Label66: TLabel;
    Label67: TLabel;
    Edit13: TEdit;
    Panel25: TPanel;
    Image25: TImage;
    Label68: TLabel;
    Memo20: TMemo;
    Label69: TLabel;
    ComboBox10: TComboBox;
    Label70: TLabel;
    Label71: TLabel;
    ComboBox11: TComboBox;
    Edit15: TEdit;
    TabSheet8: TTabSheet;
    GroupBox21: TGroupBox;
    Label75: TLabel;
    Edit16: TEdit;
    GroupBox22: TGroupBox;
    Label76: TLabel;
    Label77: TLabel;
    Memo21: TMemo;
    Memo22: TMemo;
    Panel28: TPanel;
    Image28: TImage;
    Label78: TLabel;
    Label72: TLabel;
    Edit17: TEdit;
    Label73: TLabel;
    Edit18: TEdit;
    Panel29: TPanel;
    Image29: TImage;
    TabSheet9: TTabSheet;
    GroupBox23: TGroupBox;
    Label80: TLabel;
    Label81: TLabel;
    Label82: TLabel;
    ComboBox13: TComboBox;
    Panel30: TPanel;
    Image30: TImage;
    Edit19: TEdit;
    GroupBox24: TGroupBox;
    Label83: TLabel;
    Label84: TLabel;
    Memo23: TMemo;
    Memo24: TMemo;
    Panel32: TPanel;
    Image32: TImage;
    Label86: TLabel;
    GroupBox25: TGroupBox;
    SpeedButton7: TSpeedButton;
    Label87: TLabel;
    Edit20: TEdit;
    Panel33: TPanel;
    Image33: TImage;
    Label89: TLabel;
    Label79: TLabel;
    Memo25: TMemo;
    Panel31: TPanel;
    Image31: TImage;
    Label85: TLabel;
    Panel34: TPanel;
    Image34: TImage;
    Label88: TLabel;
    Label90: TLabel;
    Edit21: TEdit;
    TabSheet10: TTabSheet;
    GroupBox26: TGroupBox;
    Label91: TLabel;
    Label92: TLabel;
    Label93: TLabel;
    Label94: TLabel;
    ComboBox12: TComboBox;
    Panel35: TPanel;
    Image35: TImage;
    Edit22: TEdit;
    Edit23: TEdit;
    GroupBox27: TGroupBox;
    Label95: TLabel;
    Label96: TLabel;
    Memo26: TMemo;
    Memo27: TMemo;
    Panel36: TPanel;
    Image36: TImage;
    Label97: TLabel;
    Panel37: TPanel;
    Image37: TImage;
    Label98: TLabel;
    GroupBox28: TGroupBox;
    SpeedButton8: TSpeedButton;
    Label99: TLabel;
    Panel38: TPanel;
    Label101: TLabel;
    Image38: TImage;
    Edit24: TEdit;
    Panel39: TPanel;
    Image39: TImage;
    Label102: TLabel;
    Label104: TLabel;
    Memo29: TMemo;
    Edit25: TEdit;
    Label100: TLabel;
    SpeedButton9: TSpeedButton;
    Label105: TLabel;
    Edit26: TEdit;
    SpeedButton10: TSpeedButton;
    Label108: TLabel;
    Label109: TLabel;
    Label110: TLabel;
    TabSheet11: TTabSheet;
    TabSheet12: TTabSheet;
    GroupBox30: TGroupBox;
    Label113: TLabel;
    Label114: TLabel;
    Label116: TLabel;
    Memo30: TMemo;
    Memo31: TMemo;
    Panel40: TPanel;
    Image40: TImage;
    Label115: TLabel;
    Memo32: TMemo;
    GroupBox29: TGroupBox;
    Label112: TLabel;
    ComboBox14: TComboBox;
    Panel41: TPanel;
    Image41: TImage;
    Label117: TLabel;
    Label118: TLabel;
    ComboBox15: TComboBox;
    Label119: TLabel;
    Label120: TLabel;
    ComboBox16: TComboBox;
    ComboBox17: TComboBox;
    Label121: TLabel;
    ComboBox18: TComboBox;
    Label122: TLabel;
    ComboBox19: TComboBox;
    Label123: TLabel;
    ComboBox20: TComboBox;
    Label124: TLabel;
    ComboBox21: TComboBox;
    Label125: TLabel;
    ComboBox22: TComboBox;
    ComboBox23: TComboBox;
    Label126: TLabel;
    Label127: TLabel;
    ComboBox24: TComboBox;
    Label128: TLabel;
    ComboBox25: TComboBox;
    TabSheet13: TTabSheet;
    TabSheet14: TTabSheet;
    TabSheet15: TTabSheet;
    Memo28: TMemo;
    Label103: TLabel;
    Label111: TLabel;
    GroupBox31: TGroupBox;
    Label130: TLabel;
    Label131: TLabel;
    Label132: TLabel;
    Label134: TLabel;
    Panel42: TPanel;
    Image42: TImage;
    Edit27: TEdit;
    Edit28: TEdit;
    ComboBox27: TComboBox;
    GroupBox32: TGroupBox;
    Label135: TLabel;
    Label136: TLabel;
    Memo33: TMemo;
    Memo34: TMemo;
    Panel43: TPanel;
    Image43: TImage;
    Label137: TLabel;
    GroupBox33: TGroupBox;
    SpeedButton11: TSpeedButton;
    Label138: TLabel;
    Label139: TLabel;
    Edit29: TEdit;
    Panel44: TPanel;
    Image44: TImage;
    Label140: TLabel;
    Memo35: TMemo;
    GroupBox34: TGroupBox;
    Label142: TLabel;
    ComboBox29: TComboBox;
    GroupBox35: TGroupBox;
    Label143: TLabel;
    Label144: TLabel;
    Memo36: TMemo;
    Memo37: TMemo;
    Panel45: TPanel;
    Image45: TImage;
    Label145: TLabel;
    GroupBox36: TGroupBox;
    SpeedButton12: TSpeedButton;
    Label146: TLabel;
    Label147: TLabel;
    Edit30: TEdit;
    Panel46: TPanel;
    Image46: TImage;
    Label148: TLabel;
    Memo38: TMemo;
    GroupBox37: TGroupBox;
    Label149: TLabel;
    Label150: TLabel;
    Label151: TLabel;
    Label152: TLabel;
    Label154: TLabel;
    Edit31: TEdit;
    Edit32: TEdit;
    Edit33: TEdit;
    Panel47: TPanel;
    Image47: TImage;
    ComboBox30: TComboBox;
    GroupBox38: TGroupBox;
    Label155: TLabel;
    Label156: TLabel;
    Memo39: TMemo;
    Memo40: TMemo;
    Panel48: TPanel;
    Image48: TImage;
    Label157: TLabel;
    Edit34: TEdit;
    Label129: TLabel;
    Label133: TLabel;
    Label141: TLabel;
    GroupBox39: TGroupBox;
    SpeedButton13: TSpeedButton;
    Label153: TLabel;
    Label158: TLabel;
    SpeedButton14: TSpeedButton;
    Edit35: TEdit;
    Panel49: TPanel;
    Image49: TImage;
    Label159: TLabel;
    Panel50: TPanel;
    Image50: TImage;
    Label160: TLabel;
    Edit36: TEdit;
    Label161: TLabel;
    ComboBox26: TComboBox;
    SpeedButton15: TSpeedButton;
    Label74: TLabel;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    ProgressBar3: TProgressBar;
    ProgressBar4: TProgressBar;
    ProgressBar5: TProgressBar;
    ProgressBar6: TProgressBar;
    ProgressBar7: TProgressBar;
    ProgressBar8: TProgressBar;
    ProgressBar9: TProgressBar;
    TabSheet16: TTabSheet;
    TabSheet17: TTabSheet;
    PageControl2: TPageControl;
    TabSheet18: TTabSheet;
    TabSheet19: TTabSheet;
    Panel51: TPanel;
    Label162: TLabel;
    Button1: TButton;
    Edit37: TEdit;
    Panel52: TPanel;
    Label163: TLabel;
    Button2: TButton;
    Edit38: TEdit;
    Panel53: TPanel;
    Panel54: TPanel;
    Panel55: TPanel;
    Panel56: TPanel;
    Panel57: TPanel;
    Panel58: TPanel;
    Panel59: TPanel;
    Panel60: TPanel;
    Panel61: TPanel;
    Label164: TLabel;
    ComboBox28: TComboBox;
    Label165: TLabel;
    ComboBox31: TComboBox;
    ComboBox32: TComboBox;
    Label166: TLabel;
    Label167: TLabel;
    Edit39: TEdit;
    Label168: TLabel;
    Edit40: TEdit;
    Label169: TLabel;
    Label170: TLabel;
    Label171: TLabel;
    Label172: TLabel;
    Edit41: TEdit;
    Edit42: TEdit;
    Edit43: TEdit;
    Edit44: TEdit;
    Button3: TButton;
    Label173: TLabel;
    SaveDialog1: TSaveDialog;
    Label174: TLabel;
    Label175: TLabel;
    Label176: TLabel;
    Panel62: TPanel;
    Label177: TLabel;
    Edit45: TEdit;
    Panel63: TPanel;
    Label178: TLabel;
    Edit46: TEdit;
    Panel64: TPanel;
    Label179: TLabel;
    Edit47: TEdit;
    Panel65: TPanel;
    Label180: TLabel;
    Edit48: TEdit;
    Panel66: TPanel;
    Label181: TLabel;
    Edit49: TEdit;
    Panel67: TPanel;
    Label182: TLabel;
    Edit50: TEdit;
    CheckBox1: TCheckBox;
    Panel68: TPanel;
    Button4: TButton;
    Edit51: TEdit;
    Panel69: TPanel;
    Label183: TLabel;
    Edit52: TEdit;
    Panel70: TPanel;
    Label184: TLabel;
    Edit53: TEdit;
    Panel71: TPanel;
    Label185: TLabel;
    Edit54: TEdit;
    Label186: TLabel;
    Edit55: TEdit;
    Label187: TLabel;
    Edit56: TEdit;
    Panel72: TPanel;
    Label188: TLabel;
    Label189: TLabel;
    Panel73: TPanel;
    Label190: TLabel;
    Edit57: TEdit;
    Edit58: TEdit;
    Panel74: TPanel;
    Label191: TLabel;
    Edit59: TEdit;
    Edit60: TEdit;
    Panel75: TPanel;
    Label192: TLabel;
    Edit61: TEdit;
    Edit62: TEdit;
    Panel76: TPanel;
    Label193: TLabel;
    Edit63: TEdit;
    Edit64: TEdit;
    Panel77: TPanel;
    Label194: TLabel;
    Edit65: TEdit;
    Edit66: TEdit;
    Panel78: TPanel;
    Label195: TLabel;
    Edit67: TEdit;
    Panel79: TPanel;
    Label196: TLabel;
    Edit68: TEdit;
    Edit69: TEdit;
    Panel80: TPanel;
    Label197: TLabel;
    Label198: TLabel;
    Edit70: TEdit;
    Edit71: TEdit;
    Panel81: TPanel;
    Label199: TLabel;
    Edit72: TEdit;
    Panel82: TPanel;
    Label200: TLabel;
    Label201: TLabel;
    Panel83: TPanel;
    Label202: TLabel;
    Edit73: TEdit;
    Edit74: TEdit;
    Label203: TLabel;
    ComboBox33: TComboBox;
    TabSheet20: TTabSheet;
    TabSheet21: TTabSheet;
    Panel84: TPanel;
    Panel85: TPanel;
    Panel86: TPanel;
    Panel87: TPanel;
    Panel88: TPanel;
    Panel89: TPanel;
    Label106: TLabel;
    Label107: TLabel;
    Label204: TLabel;
    Label205: TLabel;
    Edit75: TEdit;
    Edit76: TEdit;
    Edit77: TEdit;
    Edit78: TEdit;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Memo41: TMemo;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label206: TLabel;
    Panel90: TPanel;
    Panel91: TPanel;
    Label207: TLabel;
    Edit79: TEdit;
    Button10: TButton;
    Button11: TButton;
    Memo42: TMemo;
    RadioButton3: TRadioButton;
    Panel92: TPanel;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    Panel93: TPanel;
    Label208: TLabel;
    Edit80: TEdit;
    Button12: TButton;
    Panel94: TPanel;
    Panel95: TPanel;
    Panel96: TPanel;
    Label209: TLabel;
    Edit81: TEdit;
    Button13: TButton;
    AESMAC: TAESMAC;
    AESGCM: TAESGCM;
    ECC: TECCEncSign;
    Conv: TConvert;
    RSA: TRSAEncSign;
    SHA2: TSHA2Hash;
    SHA3: TSHA3Hash;
    Blake2B: TBlake2BHash;
    RIPEMD160: TRIPEMD160Hash;
    PBKDF2: TPBKDF2KeyDerivation;
    Argon2: TArgon2KeyDerivation;
    Salsa: TSalsaEncryption;
    SPECK: TSPECKEncryption;
    X509Cert: TX509Certificate;
    AES: TAESEncryption;
    XAdES: TXAdES;
    CAdES: TCAdES;
    PAdES: TPAdES;
    TabSheet22: TTabSheet;
    Panel97: TPanel;
    Label210: TLabel;
    Edit82: TEdit;
    Panel98: TPanel;
    Label211: TLabel;
    Edit83: TEdit;
    Panel99: TPanel;
    Label212: TLabel;
    Edit84: TEdit;
    Panel100: TPanel;
    Label213: TLabel;
    Label214: TLabel;
    Label215: TLabel;
    Label216: TLabel;
    Button14: TButton;
    Panel101: TPanel;
    Label217: TLabel;
    Edit85: TEdit;
    Panel102: TPanel;
    Label218: TLabel;
    Edit86: TEdit;
    Panel103: TPanel;
    Label219: TLabel;
    Button15: TButton;
    Edit87: TEdit;
    Panel104: TPanel;
    Label220: TLabel;
    Button16: TButton;
    Edit88: TEdit;
    Panel105: TPanel;
    Label221: TLabel;
    Label222: TLabel;
    ComboBox34: TComboBox;
    ComboBox35: TComboBox;
    Panel106: TPanel;
    Label223: TLabel;
    ComboBox36: TComboBox;
    Panel107: TPanel;
    Label224: TLabel;
    Edit89: TEdit;
    X509CSR: TX509CSR;
    TabSheet23: TTabSheet;
    Panel108: TPanel;
    Label225: TLabel;
    Button17: TButton;
    Edit90: TEdit;
    Panel109: TPanel;
    Label226: TLabel;
    Button18: TButton;
    Edit91: TEdit;
    Panel110: TPanel;
    Label227: TLabel;
    Button19: TButton;
    Edit92: TEdit;
    Panel111: TPanel;
    Label228: TLabel;
    Button20: TButton;
    Edit93: TEdit;
    Panel112: TPanel;
    Label230: TLabel;
    Label231: TLabel;
    Label232: TLabel;
    Button21: TButton;
    TabSheet24: TTabSheet;
    GroupBox40: TGroupBox;
    Label229: TLabel;
    Label234: TLabel;
    Label235: TLabel;
    Label236: TLabel;
    Edit94: TEdit;
    Edit96: TEdit;
    Panel113: TPanel;
    Image51: TImage;
    ComboBox37: TComboBox;
    ComboBox38: TComboBox;
    GroupBox41: TGroupBox;
    Label237: TLabel;
    Label238: TLabel;
    Memo43: TMemo;
    Memo44: TMemo;
    Panel114: TPanel;
    Image52: TImage;
    Label239: TLabel;
    GroupBox42: TGroupBox;
    Label240: TLabel;
    Label241: TLabel;
    Memo45: TMemo;
    Memo46: TMemo;
    Panel115: TPanel;
    Image53: TImage;
    Label242: TLabel;
    HKDF: THKDFKeyDerivation;
    Panel116: TPanel;
    Panel117: TPanel;
    Label233: TLabel;
    Edit95: TEdit;
    Button22: TButton;
    Panel118: TPanel;
    Label243: TLabel;
    Edit97: TEdit;
    tlsh: Ttlsh;
    TabSheet25: TTabSheet;
    PageControlTLSH: TPageControl;
    TabSheet29: TTabSheet;
    InfoEdit: TEdit;
    Label247: TLabel;
    Label248: TLabel;
    Label249: TLabel;
    TabSheet30: TTabSheet;
    GroupBox44: TGroupBox;
    SpeedButton16: TSpeedButton;
    Label251: TLabel;
    Label252: TLabel;
    Edit99: TEdit;
    Panel124: TPanel;
    Image55: TImage;
    Label253: TLabel;
    GroupBox45: TGroupBox;
    SpeedButton17: TSpeedButton;
    Label254: TLabel;
    Label255: TLabel;
    Edit101: TEdit;
    Panel125: TPanel;
    Image56: TImage;
    Label256: TLabel;
    Edit102: TEdit;
    Memo48: TMemo;
    Panel126: TPanel;
    Panel127: TPanel;
    Panel128: TPanel;
    Panel129: TPanel;
    Panel130: TPanel;
    Panel131: TPanel;
    Panel132: TPanel;
    Panel133: TPanel;
    Panel134: TPanel;
    Panel135: TPanel;
    Panel136: TPanel;
    GroupBox46: TGroupBox;
    CheckBox3: TCheckBox;
    Edit98: TEdit;
    SpeedButton18: TSpeedButton;
    Panel119: TPanel;
    Panel120: TPanel;
    SpeedButton19: TSpeedButton;
    Edit100: TEdit;
    Panel122: TPanel;
    Panel123: TPanel;
    Panel137: TPanel;
    Image54: TImage;
    Label244: TLabel;
    GroupBox47: TGroupBox;
    Label245: TLabel;
    Label246: TLabel;
    Label250: TLabel;
    Panel121: TPanel;
    procedure Panel1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Panel3Click(Sender: TObject);
    procedure Panel4Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Image5Click(Sender: TObject);
    procedure Image30Click(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Image10Click(Sender: TObject);
    procedure Panel6Click(Sender: TObject);
    procedure Panel7Click(Sender: TObject);
    procedure Panel8Click(Sender: TObject);
    procedure Panel9Click(Sender: TObject);
    procedure Image11Click(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure Panel12Click(Sender: TObject);
    procedure Panel13Click(Sender: TObject);
    procedure Panel14Click(Sender: TObject);
    procedure Panel15Click(Sender: TObject);
    procedure Edit9Change(Sender: TObject);
    procedure Image16Click(Sender: TObject);
    procedure Panel18Click(Sender: TObject);
    procedure Panel17Click(Sender: TObject);
    procedure Panel19Click(Sender: TObject);
    procedure Panel20Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Edit12Change(Sender: TObject);
    procedure Image21Click(Sender: TObject);
    procedure Panel23Click(Sender: TObject);
    procedure Panel22Click(Sender: TObject);
    procedure Panel26Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure Panel27Click(Sender: TObject);
    procedure ComboBox10Select(Sender: TObject);
    procedure Edit15Change(Sender: TObject);
    procedure Panel24Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure Panel25Click(Sender: TObject);
    procedure Edit18Change(Sender: TObject);
    procedure Image29Click(Sender: TObject);
    procedure Panel28Click(Sender: TObject);
    procedure Edit19Change(Sender: TObject);
    procedure Panel32Click(Sender: TObject);
    procedure Panel31Click(Sender: TObject);
    procedure Panel33Click(Sender: TObject);
    procedure Panel34Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure Edit22Change(Sender: TObject);
    procedure Image35Click(Sender: TObject);
    procedure Panel36Click(Sender: TObject);
    procedure Panel37Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure Panel38Click(Sender: TObject);
    procedure Panel39Click(Sender: TObject);
    procedure Edit13Change(Sender: TObject);
    procedure Edit14Change(Sender: TObject);
    procedure Label111Click(Sender: TObject);
    procedure Panel40Click(Sender: TObject);
    procedure Panel41Click(Sender: TObject);
    procedure ComboBox20Select(Sender: TObject);
    procedure ComboBox25Select(Sender: TObject);
    procedure Edit27Change(Sender: TObject);
    procedure Panel43Click(Sender: TObject);
    procedure Panel44Click(Sender: TObject);
    procedure Image42Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure Panel45Click(Sender: TObject);
    procedure Edit30Change(Sender: TObject);
    procedure Panel46Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure Image47Click(Sender: TObject);
    procedure Edit33Change(Sender: TObject);
    procedure Panel48Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure Panel49Click(Sender: TObject);
    procedure Panel50Click(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Edit8Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure ComboBox4Select(Sender: TObject);
    procedure ComboBox3Select(Sender: TObject);
    procedure ComboBox33Select(Sender: TObject);
    procedure ComboBox31Select(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure ComboBox35Select(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Image51Click(Sender: TObject);
    procedure Panel115Click(Sender: TObject);
    procedure Edit94Change(Sender: TObject);
    procedure Panel114Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure SpeedButton17Click(Sender: TObject);
    procedure Panel125Click(Sender: TObject);
    procedure Edit101Change(Sender: TObject);
    procedure SpeedButton16Click(Sender: TObject);
    procedure Panel124Click(Sender: TObject);
    procedure Edit99Change(Sender: TObject);
    procedure Edit100Change(Sender: TObject);
    procedure SpeedButton19Click(Sender: TObject);
    procedure SpeedButton18Click(Sender: TObject);
    procedure Panel137Click(Sender: TObject);
  private
    { Private declarations }
    Combo20Item: Integer;
    Combo25Item: Integer;
    procedure AESOnChange(Sender: TObject);
    procedure SPECKOnChange(Sender: TObject);
    procedure SalsaOnChange(Sender: TObject);
    procedure AESMACOnChange(Sender: TObject);
    procedure AESGCMOnChange(Sender: TObject);
    procedure SHA2OnChange(Sender: TObject);
    procedure SHA3OnChange(Sender: TObject);
    procedure Blake2BOnChange(Sender: TObject);
    procedure RIPEMD160OnChange(Sender: TObject);
    function SearchAll(aPath: string; aPattern: string;
      aList: TStringList): Boolean;
  public
    { Public declarations }
    procedure FromOpenSSLEncPrivateKeyAskPassword(Sender: TObject;
      const filePath: string);
    procedure FromPFXAskPassword(Sender: TObject; const filePath: string;
      const SignatureType: Integer);
    procedure EnableButtons(bfOn: Boolean);
    procedure EnableButtonsCSR(bfOn: Boolean);
  end;

var
  Form5: TForm5;

implementation

{$R *.dfm}

procedure TForm5.Edit1Change(Sender: TObject);
var
  kl: Integer;
  keyOK, fileEncOK, fileDecOK: Boolean;
begin
  case ComboBox2.ItemIndex of
    0:
      kl := 16;
    1:
      kl := 24;
  else
    kl := 32;
  end;

  Label4.Caption := '(' + inttostr(length(Edit1.Text)) + '/' +
    inttostr(kl) + ')';

  keyOK := length(Edit1.Text) = kl;

  fileEncOK := (Edit2.Text <> '') and (FileExists(Edit2.Text));

  fileDecOK := (Edit3.Text <> '') and (FileExists(Edit3.Text));

  if keyOK then
    Edit1.Color := clLime
  else
    Edit1.Color := clRed;

  Panel1.Enabled := keyOK;
  Panel2.Enabled := keyOK;
  Label7.Enabled := keyOK;
  Label8.Enabled := keyOK;
  Image1.Enabled := keyOK;
  Image2.Enabled := keyOK;

  Panel3.Enabled := keyOK and fileEncOK;
  Panel4.Enabled := keyOK and fileDecOK;
  Label9.Enabled := keyOK and fileEncOK;
  Label10.Enabled := keyOK and fileDecOK;
  Image3.Enabled := keyOK and fileEncOK;
  Image4.Enabled := keyOK and fileDecOK;
end;

procedure TForm5.FormCreate(Sender: TObject);
begin
  Edit1Change(Self);
  Edit4Change(Self);
  Edit7Change(Self);
  Edit9Change(Self);
  Edit12Change(Self);
  Edit15Change(Self);
  Edit18Change(Self);
  Edit19Change(Self);
  Edit22Change(Self);
  Combo20Item := 0;
  Combo25Item := 0;
  ReportMemoryLeaksOnShutdown := true;
end;

procedure TForm5.Image10Click(Sender: TObject);
begin
  case ComboBox3.ItemIndex of
    0:
      RSA.KeyLength := kl2048;
    1:
      RSA.KeyLength := kl3072;
  else
    RSA.KeyLength := kl4096;
  end;

  case ComboBox20.ItemIndex of
    0:
      begin
        RSA.OutputFormat := hexa;
        Conv.AType := hexa;
      end;
    1:
      begin
        RSA.OutputFormat := base64;
        Conv.AType := base64;
      end;
    2:
      begin
        RSA.OutputFormat := base64url;
        Conv.AType := base64url;
      end
  else
    begin
      RSA.OutputFormat := base32;
      Conv.AType := base32;
    end;
  end;

  Label110.Visible := true;
  Refresh();
  RSA.GenerateKeys();
  Label110.Visible := false;
  Edit4.Text := Conv.KeyTRSAEncSignToKeyRSAOpenSSL(RSA.Modulus);
  Edit5.Text := Conv.KeyTRSAEncSignToKeyRSAOpenSSL(RSA.PublicExponent);
  Edit6.Text := Conv.KeyTRSAEncSignToKeyRSAOpenSSL(RSA.PrivateExponent);

end;

procedure TForm5.Image51Click(Sender: TObject);
var
  s: string;
begin
  // convert to hexa to display printable characters
  Conv.AType := hexa;
  s := Conv.RandomString(8);

  Edit96.Text := s;

end;

procedure TForm5.Image5Click(Sender: TObject);
var
  s: string;
  kl: Integer;
begin
  case ComboBox2.ItemIndex of
    0:
      kl := 16;
    1:
      kl := 24;
  else
    kl := 32;
  end;

  // convert to hexa to display printable characters
  Conv.AType := hexa;
  s := Conv.RandomString(kl div 2);

  Edit1.Text := s;

end;

procedure TForm5.Label111Click(Sender: TObject);
var
  MyLink: string;
begin
  MyLink := 'http://www.tmssoftware.com/site/tmscrypto.asp';
  ShellExecute(Application.Handle, PChar('open'), PChar(MyLink), nil, nil,
    SW_SHOWNORMAL);
end;

procedure TForm5.Image30Click(Sender: TObject);
var
  s: string;
  kl: Integer;
begin
  case ComboBox13.ItemIndex of
    0:
      kl := 16;
    1:
      kl := 24;
  else
    kl := 32;
  end;

  // convert to hexa to display printable characters
  Conv.AType := hexa;
  s := Conv.RandomString(kl div 2);

  Edit19.Text := s;

end;

procedure TForm5.Panel1Click(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0:
      AES.AType := atECB;
    1:
      AES.AType := atCBC;
    2:
      AES.AType := atOFB;
  else
    AES.AType := atCTR;
  end;

  case ComboBox2.ItemIndex of
    0:
      AES.KeyLength := kl128;
    1:
      AES.KeyLength := kl192;
  else
    AES.KeyLength := kl256;
  end;

  case ComboBox15.ItemIndex of
    0:
      AES.OutputFormat := hexa;
    1:
      AES.OutputFormat := base64;
    2:
      AES.OutputFormat := base64url;
  else
    AES.OutputFormat := base32;
  end;

  AES.Key := Edit1.Text;
  AES.PaddingMode := TPaddingMode.PKCS7;
  AES.IVMode := TIVMode.rand;
  AES.Unicode := yesUni;

  Memo2.Text := AES.Encrypt(Memo1.Text);
end;

procedure TForm5.Panel2Click(Sender: TObject);
begin
  Memo1.Color := clGrayText;
  case ComboBox1.ItemIndex of
    0:
      AES.AType := atECB;
    1:
      AES.AType := atCBC;
    2:
      AES.AType := atOFB;
  else
    AES.AType := atCTR;
  end;

  case ComboBox2.ItemIndex of
    0:
      AES.KeyLength := kl128;
    1:
      AES.KeyLength := kl192;
  else
    AES.KeyLength := kl256;
  end;

  case ComboBox15.ItemIndex of
    0:
      AES.OutputFormat := hexa;
    1:
      AES.OutputFormat := base64;
    2:
      AES.OutputFormat := base64url;
  else
    AES.OutputFormat := base32;
  end;

  AES.Key := Edit1.Text;
  AES.PaddingMode := TPaddingMode.PKCS7;
  AES.IVMode := TIVMode.userdefined;
  AES.IV := '';
  AES.Unicode := yesUni;

  Memo1.Text := AES.Decrypt(Memo2.Text);
  Refresh();
  sleep(30);
  Memo1.Color := clWindow;
end;

procedure TForm5.Panel3Click(Sender: TObject);
var
  s: string;
  f: Integer;
begin

  case ComboBox1.ItemIndex of
    0:
      AES.AType := atECB;
    1:
      AES.AType := atCBC;
    2:
      AES.AType := atOFB;
  else
    AES.AType := atCTR;
  end;

  case ComboBox2.ItemIndex of
    0:
      AES.KeyLength := kl128;
    1:
      AES.KeyLength := kl192;
  else
    AES.KeyLength := kl256;
  end;

  AES.PaddingMode := TPaddingMode.PKCS7;
  AES.IVMode := TIVMode.rand;

  AES.Key := Edit1.Text;
  AES.Unicode := yesUni;
  AES.OnChange := AESOnChange;
  if FileExists(Edit2.Text) then
  begin
    if FileExists(Edit3.Text) then
      if Edit2.Text <> Edit3.Text then
        AES.EncryptFileW(Edit2.Text, Edit3.Text)
      else
        raise Exception.Create
          ('Impossible to encrypt the file in the same file')
    else
    begin
      if Edit3.Text = '' then
      begin
        s := Edit2.Text + '.enc';
        AES.EncryptFileW(Edit2.Text, s);
        Edit3.Text := s;
      end
      else
      begin
        f := FileCreate(Edit3.Text);
        if f <> -1 then
        begin
          FileClose(f);
          AES.EncryptFileW(Edit2.Text, Edit3.Text);
        end
        else
          raise Exception.Create('Impossible to create the output file');
      end;
    end;
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;
end;

procedure TForm5.Panel40Click(Sender: TObject);
begin
  Panel41.Color := clBtnFace;
  case ComboBox14.ItemIndex of
    0:
      SHA2.HashSizeBits := 256;
    1:
      SHA2.HashSizeBits := 384;
    2:
      SHA2.HashSizeBits := 512;
    3:
      begin
        SHA3.AType := tsha;
        SHA3.HashSizeBits := 224;
      end;
    4:
      begin
        SHA3.AType := tsha;
        SHA3.HashSizeBits := 256;
      end;
    5:
      begin
        SHA3.AType := tsha;
        SHA3.HashSizeBits := 384;
      end;
    6:
      begin
        SHA3.AType := tsha;
        SHA3.HashSizeBits := 512;
      end;
  else
    begin
      SHA3.AType := txof;
      SHA3.version := 256;
      SHA3.HashSizeBits := 1024;
    end;
  end;

  case ComboBox24.ItemIndex of
    0:
      begin
        SHA2.OutputFormat := hexa;
        SHA3.OutputFormat := hexa;
      end;
    1:
      begin
        SHA2.OutputFormat := base64;
        SHA3.OutputFormat := base64;
      end;
    2:
      begin
        SHA2.OutputFormat := base64url;
        SHA3.OutputFormat := base64url;
      end
  else
    begin
      SHA2.OutputFormat := base32;
      SHA3.OutputFormat := base32;
    end;
  end;

  SHA2.Unicode := yesUni;
  SHA3.Unicode := yesUni;
  if ComboBox14.ItemIndex < 2 then
  begin
    Memo31.Text := SHA2.HMAC(Memo30.Text, Memo32.Text);
  end
  else
  begin
    Memo31.Text := SHA3.HMAC(Memo30.Text, Memo32.Text);
  end;
end;

procedure TForm5.Panel41Click(Sender: TObject);
var
  err: Integer;
begin

  case ComboBox14.ItemIndex of
    0:
      SHA2.HashSizeBits := 256;
    1:
      SHA2.HashSizeBits := 384;
    2:
      SHA2.HashSizeBits := 512;
    3:
      begin
        SHA3.AType := tsha;
        SHA3.HashSizeBits := 224;
      end;
    4:
      begin
        SHA3.AType := tsha;
        SHA3.HashSizeBits := 256;
      end;
    5:
      begin
        SHA3.AType := tsha;
        SHA3.HashSizeBits := 384;
      end;
    6:
      begin
        SHA3.AType := tsha;
        SHA3.HashSizeBits := 512;
      end;
  else
    begin
      SHA3.AType := txof;
      SHA3.version := 256;
      SHA3.HashSizeBits := 1024;
    end;
  end;

  case ComboBox24.ItemIndex of
    0:
      begin
        SHA2.OutputFormat := hexa;
        SHA3.OutputFormat := hexa;
      end;
    1:
      begin
        SHA2.OutputFormat := base64;
        SHA3.OutputFormat := base64;
      end;
    2:
      begin
        SHA2.OutputFormat := base64url;
        SHA3.OutputFormat := base64url;
      end
  else
    begin
      SHA2.OutputFormat := base32;
      SHA3.OutputFormat := base32;
    end;
  end;

  SHA2.Unicode := yesUni;
  SHA3.Unicode := yesUni;

  if ComboBox14.ItemIndex < 2 then
    err := SHA2.VerifyHMAC(Memo30.Text, Memo32.Text, Memo31.Text)
  else
    err := SHA3.VerifyHMAC(Memo30.Text, Memo32.Text, Memo31.Text);
  if err = 0 then
    Panel41.Color := clLime
  else
    Panel41.Color := clRed;
end;

procedure TForm5.Panel43Click(Sender: TObject);
begin
  Blake2B.Key := Edit27.Text;
  Blake2B.HashSizeBytes := StrToInt(Edit28.Text);

  case ComboBox27.ItemIndex of
    0:
      Blake2B.OutputFormat := hexa;
    1:
      Blake2B.OutputFormat := base64;
    2:
      Blake2B.OutputFormat := base64url;
  else
    Blake2B.OutputFormat := base32;
  end;

  Blake2B.Unicode := yesUni;
  Memo34.Text := Blake2B.Hash(Memo33.Text);
end;

procedure TForm5.Panel44Click(Sender: TObject);
begin

  Blake2B.Key := Edit27.Text;
  Blake2B.HashSizeBytes := StrToInt(Edit28.Text);

  case ComboBox27.ItemIndex of
    0:
      Blake2B.OutputFormat := hexa;
    1:
      Blake2B.OutputFormat := base64;
    2:
      Blake2B.OutputFormat := base64url;
  else
    Blake2B.OutputFormat := base32;
  end;

  Blake2B.Unicode := yesUni;
  Blake2B.OnChange := Blake2BOnChange;
  Memo35.Text := Blake2B.HashFile(Edit29.Text);

end;

procedure TForm5.Panel45Click(Sender: TObject);
begin

  case ComboBox29.ItemIndex of
    0:
      RIPEMD160.OutputFormat := hexa;
    1:
      RIPEMD160.OutputFormat := base64;
    2:
      RIPEMD160.OutputFormat := base64url;
  else
    RIPEMD160.OutputFormat := base32;
  end;

  RIPEMD160.Unicode := yesUni;
  Memo37.Text := RIPEMD160.Hash(Memo36.Text);
end;

procedure TForm5.Panel46Click(Sender: TObject);
begin

  case ComboBox29.ItemIndex of
    0:
      RIPEMD160.OutputFormat := hexa;
    1:
      RIPEMD160.OutputFormat := base64;
    2:
      RIPEMD160.OutputFormat := base64url;
  else
    RIPEMD160.OutputFormat := base32;
  end;
  RIPEMD160.Unicode := yesUni;
  RIPEMD160.OnChange := RIPEMD160OnChange;
  Memo38.Text := RIPEMD160.HashFile(Edit30.Text);

end;

procedure TForm5.Panel48Click(Sender: TObject);
begin
  case ComboBox30.ItemIndex of
    0:
      Argon2.OutputFormat := hexa;
    1:
      Argon2.OutputFormat := base64;
    2:
      Argon2.OutputFormat := base64url;
  else
    Argon2.OutputFormat := base32;
  end;

  Argon2.Unicode := yesUni;
  Argon2.OutputSizeBytes := StrToInt(Edit31.Text);
  Argon2.Counter := StrToInt(Edit32.Text);
  Argon2.Memory := StrToInt(Edit34.Text);
  Argon2.StringSalt := Edit33.Text;

  Memo40.Text := Argon2.GenerateKey(Memo39.Text);
end;

procedure TForm5.Panel49Click(Sender: TObject);
var
  s: string;
  f: Integer;
begin
  case ComboBox8.ItemIndex of
    0:
      Salsa.KeyLength := skl128;
  else
    Salsa.KeyLength := skl256;
  end;

  case ComboBox19.ItemIndex of
    0:
      Salsa.OutputFormat := hexa;
    1:
      Salsa.OutputFormat := base64;
    2:
      Salsa.OutputFormat := base64url;
  else
    Salsa.OutputFormat := base32;
  end;

  Salsa.Key := Edit12.Text;
  Salsa.Unicode := yesUni;
  Salsa.OnChange := SalsaOnChange;
  if FileExists(Edit35.Text) then
  begin
    if FileExists(Edit36.Text) then
      if Edit35.Text <> Edit36.Text then
        Salsa.EncryptFile(Edit35.Text, Edit36.Text)
      else
        raise Exception.Create
          ('Impossible to encrypt the file in the same file')
    else
    begin
      if Edit3.Text = '' then
      begin
        s := Edit35.Text + '.enc';
        Salsa.EncryptFile(Edit35.Text, s);
        Edit36.Text := s;
      end
      else
      begin
        f := FileCreate(Edit36.Text);
        if f <> -1 then
        begin
          FileClose(f);
          Salsa.EncryptFile(Edit35.Text, Edit36.Text)
        end
        else
          raise Exception.Create('Impossible to create the output file');
      end;
    end;
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;
end;

procedure TForm5.Panel4Click(Sender: TObject);
var
  f: Integer;
  s: string;
begin
  case ComboBox1.ItemIndex of
    0:
      AES.AType := atECB;
    1:
      AES.AType := atCBC;
    2:
      AES.AType := atOFB;
  else
    AES.AType := atCTR;
  end;

  case ComboBox2.ItemIndex of
    0:
      AES.KeyLength := kl128;
    1:
      AES.KeyLength := kl192;
  else
    AES.KeyLength := kl256;
  end;

  AES.Key := Edit1.Text;

  AES.PaddingMode := TPaddingMode.PKCS7;
  AES.IVMode := TIVMode.rand;
  AES.Unicode := yesUni;
  AES.OnChange := AESOnChange;
  if FileExists(Edit3.Text) then
  begin
    if FileExists(Edit2.Text) then
      if Edit3.Text <> Edit2.Text then
        AES.DecryptFileW(Edit3.Text, Edit2.Text)
      else
        raise Exception.Create
          ('Impossible to decrypt the file in the same file')
    else
    begin
      if Edit2.Text = '' then
      begin
        s := Edit3.Text + '.dec';
        AES.DecryptFileW(Edit3.Text, s);
        Edit2.Text := s;
      end
      else
      begin
        f := FileCreate(Edit2.Text);
        if f <> -1 then
        begin
          FileClose(f);
          AES.DecryptFileW(Edit3.Text, Edit2.Text);
        end
        else
          raise Exception.Create('Impossible to create the output file');
      end;
    end;
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;

end;

procedure TForm5.Panel50Click(Sender: TObject);
var
  s: string;
  f: Integer;
begin

  case ComboBox8.ItemIndex of
    0:
      Salsa.KeyLength := skl128;
  else
    Salsa.KeyLength := skl256;
  end;

  case ComboBox19.ItemIndex of
    0:
      Salsa.OutputFormat := hexa;
    1:
      Salsa.OutputFormat := base64;
    2:
      Salsa.OutputFormat := base64url;
  else
    Salsa.OutputFormat := base32;
  end;

  Salsa.Key := Edit12.Text;
  Salsa.Unicode := yesUni;
  Salsa.OnChange := SalsaOnChange;
  if FileExists(Edit36.Text) then
  begin
    if FileExists(Edit35.Text) then
      if Edit36.Text <> Edit35.Text then
        Salsa.DecryptFile(Edit36.Text, Edit35.Text)
      else
        raise Exception.Create
          ('Impossible to decrypt the file in the same file')
    else
    begin
      if Edit35.Text = '' then
      begin
        s := Edit36.Text + '.dec';
        Salsa.DecryptFile(Edit36.Text, s);
        Edit35.Text := s;
      end
      else
      begin
        f := FileCreate(Edit35.Text);
        if f <> -1 then
        begin
          FileClose(f);
          Salsa.DecryptFile(Edit36.Text, Edit35.Text);
        end
        else
          raise Exception.Create('Impossible to create the output file');
      end;
    end;
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;
end;

procedure TForm5.SpeedButton1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit2.Text := OpenDialog1.FileName;
    Edit1Change(Self);
  end;

end;

procedure TForm5.SpeedButton7Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit20.Text := OpenDialog1.FileName;
    Edit19Change(Self);
  end;

end;

procedure TForm5.SpeedButton8Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit24.Text := OpenDialog1.FileName;
    Edit22Change(Self);
  end;

end;

procedure TForm5.SpeedButton9Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit25.Text := OpenDialog1.FileName;
    Edit22Change(Self);
  end;

end;

procedure TForm5.SpeedButton10Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit26.Text := OpenDialog1.FileName;
    Edit22Change(Self);
  end;

end;

procedure TForm5.SpeedButton11Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit29.Text := OpenDialog1.FileName;
  end;

end;

procedure TForm5.SpeedButton12Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit30.Text := OpenDialog1.FileName;
    Edit30Change(Self);
  end;
end;

procedure TForm5.SpeedButton13Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit35.Text := OpenDialog1.FileName;
    Edit12Change(Self);
  end;

end;

procedure TForm5.SpeedButton14Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit36.Text := OpenDialog1.FileName;
    Edit12Change(Self);
  end;

end;

procedure TForm5.FromPFXAskPassword(Sender: TObject; const filePath: string;
  const SignatureType: Integer);
var
  value: string;
begin
  value := InputBox('Enter the password of the pfx file', #31'Password', '');

  if SignatureType = 0 then
    XAdES.LoadCertAndKeyFromPKCS12(filePath, value, '..\..\libWin64')
  else if SignatureType = 1 then
    CAdES.LoadCertAndKeyFromPKCS12(filePath, value, '..\..\libWin64')
  else
    PAdES.LoadCertAndKeyFromPKCS12(filePath, value, '..\..\libWin64');
end;

procedure TForm5.FromOpenSSLEncPrivateKeyAskPassword(Sender: TObject;
  const filePath: string);
var
  value: string;
begin
  value := InputBox('Enter your password', #31'Password', '');

  RSA.FromOpenSSLEncPrivateKey(filePath, value);

end;

procedure TForm5.SpeedButton15Click(Sender: TObject);
var
  t: TOpenSSLFileType;
begin
  if OpenDialog1.Execute then
  begin
    t := RSA.OpenSSLTypeFile(OpenDialog1.FileName);
    RSA.withOpenSSL := true;
    case t of
      opensslpub:
        RSA.FromOpenSSLPublicKey(OpenDialog1.FileName);
      opensslpriv:
        RSA.FromOpenSSLPrivateKey(OpenDialog1.FileName);
      opensslcert:
        RSA.FromOpenSSLCert(OpenDialog1.FileName);
      opensslencpriv:
        FromOpenSSLEncPrivateKeyAskPassword(Self, OpenDialog1.FileName);
    end;

    if RSA.Modulus <> '' then
      Edit4.Text := Conv.KeyTRSAEncSignToKeyRSAOpenSSL(RSA.Modulus);
    if RSA.PublicExponent <> '' then
      Edit5.Text := Conv.KeyTRSAEncSignToKeyRSAOpenSSL(RSA.PublicExponent);
    if RSA.PrivateExponent <> '' then
      Edit6.Text := Conv.KeyTRSAEncSignToKeyRSAOpenSSL(RSA.PrivateExponent);
  end;
end;

procedure TForm5.SpeedButton16Click(Sender: TObject);
var
  MyDirectory: string;
  DirString: string;

begin
  DirString := TPath.GetDocumentsPath;
  if SelectDirectory('Select a directory', DirString, MyDirectory) then
    Edit99.Text := MyDirectory;
end;

procedure TForm5.SpeedButton17Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit101.Text := OpenDialog1.FileName;
end;

procedure TForm5.SpeedButton18Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit98.Text := OpenDialog1.FileName;
end;

procedure TForm5.SpeedButton19Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit100.Text := OpenDialog1.FileName;
end;

procedure TForm5.SpeedButton2Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit3.Text := OpenDialog1.FileName;
    Edit1Change(Self);
  end;
end;

procedure TForm5.Edit4Change(Sender: TObject);
var
  kl: Integer;
  keyOK1, keyOK2: Boolean;
begin
  case ComboBox3.ItemIndex of
    0:
      kl := 256;
    1:
      kl := 384;
  else
    kl := 512;
  end;

  case ComboBox20.ItemIndex of
    0:
      Conv.AType := hexa;
    1:
      Conv.AType := base64;
    2:
      Conv.AType := base64url;
  else
    Conv.AType := base32;
  end;

  keyOK1 := length(Edit4.Text) = Conv.OutputFormatLength(kl) - 1;
  keyOK2 := length(Edit5.Text) >= Conv.OutputFormatLength(3) - 1;
  keyOK2 := keyOK2 and (length(Edit5.Text) <= Conv.OutputFormatLength(32) - 1);

  if keyOK1 then
  begin
    Edit4.Color := clLime;
  end
  else
  begin
    Edit4.Color := clRed;
  end;

  if keyOK2 then
  begin
    Edit5.Color := clLime;
  end
  else
  begin
    Edit5.Color := clRed;
  end;

  Panel7.Enabled := keyOK1 and keyOK2;
  Label20.Enabled := keyOK1 and keyOK2;
  Image7.Enabled := keyOK1 and keyOK2;

  Panel8.Enabled := keyOK1 and keyOK2;
  Label23.Enabled := keyOK1 and keyOK2;
  Image9.Enabled := keyOK1 and keyOK2;
end;

procedure TForm5.Edit6Change(Sender: TObject);
var
  kl: Integer;
  keyOK3: Boolean;
begin
  case ComboBox3.ItemIndex of
    0:
      kl := 256;
    1:
      kl := 384;
  else
    kl := 512;
  end;

  case ComboBox20.ItemIndex of
    0:
      Conv.AType := hexa;
    1:
      Conv.AType := base64;
    2:
      Conv.AType := base64url;
  else
    Conv.AType := base32;
  end;

  keyOK3 := length(Edit6.Text) = Conv.OutputFormatLength(kl) - 1;

  if keyOK3 then
  begin
    Edit6.Color := clLime;
  end
  else
  begin
    Edit6.Color := clRed;
  end;

  Panel6.Enabled := keyOK3;
  Label19.Enabled := keyOK3;
  Image6.Enabled := keyOK3;

  Panel9.Enabled := keyOK3;
  Label24.Enabled := keyOK3;
  Image8.Enabled := keyOK3
end;

procedure TForm5.Panel7Click(Sender: TObject);
begin
  case ComboBox3.ItemIndex of
    0:
      RSA.KeyLength := kl2048;
    1:
      RSA.KeyLength := kl3072;
  else
    RSA.KeyLength := kl4096;
  end;

  case ComboBox20.ItemIndex of
    0:
      begin
        RSA.OutputFormat := hexa;
        Conv.AType := hexa;
      end;
    1:
      begin
        RSA.OutputFormat := base64;
        Conv.AType := base64;
      end;
    2:
      begin
        RSA.OutputFormat := base64url;
        Conv.AType := base64url;
      end
  else
    begin
      RSA.OutputFormat := base32;
      Conv.AType := base32;
    end;
  end;

  RSA.Unicode := yesUni;
  RSA.Modulus := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit4.Text);
  RSA.PublicExponent := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit5.Text);
  RSA.PrivateExponent := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit6.Text);
  RSA.encType := TRSAEncType(ComboBox33.ItemIndex);
  Memo4.Text := RSA.Encrypt(Memo3.Text);

end;

procedure TForm5.Panel6Click(Sender: TObject);
begin
  Memo3.Color := clGrayText;
  case ComboBox3.ItemIndex of
    0:
      RSA.KeyLength := kl2048;
    1:
      RSA.KeyLength := kl3072;
  else
    RSA.KeyLength := kl4096;
  end;

  case ComboBox20.ItemIndex of
    0:
      begin
        RSA.OutputFormat := hexa;
        Conv.AType := hexa;
      end;
    1:
      begin
        RSA.OutputFormat := base64;
        Conv.AType := base64;
      end;
    2:
      begin
        RSA.OutputFormat := base64url;
        Conv.AType := base64url;
      end
  else
    begin
      RSA.OutputFormat := base32;
      Conv.AType := base32;
    end;
  end;

  RSA.Unicode := yesUni;
  RSA.Modulus := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit4.Text);
  RSA.PublicExponent := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit5.Text);
  RSA.PrivateExponent := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit6.Text);
  RSA.encType := TRSAEncType(ComboBox33.ItemIndex);
  Memo3.Text := RSA.Decrypt(Memo4.Text);
  Refresh();
  sleep(30);
  Memo3.Color := clWindow;

end;

procedure TForm5.Panel9Click(Sender: TObject);
begin
  Panel8.Color := clBtnFace;
  case ComboBox3.ItemIndex of
    0:
      RSA.KeyLength := kl2048;
    1:
      RSA.KeyLength := kl3072;
  else
    RSA.KeyLength := kl4096;
  end;

  case ComboBox20.ItemIndex of
    0:
      begin
        RSA.OutputFormat := hexa;
        Conv.AType := hexa;
      end;
    1:
      begin
        RSA.OutputFormat := base64;
        Conv.AType := base64;
      end;
    2:
      begin
        RSA.OutputFormat := base64url;
        Conv.AType := base64url;
      end
  else
    begin
      RSA.OutputFormat := base32;
      Conv.AType := base32;
    end;
  end;

  RSA.Unicode := yesUni;
  RSA.Modulus := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit4.Text);
  RSA.PublicExponent := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit5.Text);
  RSA.PrivateExponent := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit6.Text);

  RSA.signType := TRSASignType(ComboBox33.ItemIndex);
  Memo6.Text := RSA.Sign(Memo5.Text);

end;

procedure TForm5.Panel8Click(Sender: TObject);
var
  err: Integer;
begin
  case ComboBox3.ItemIndex of
    0:
      RSA.KeyLength := kl2048;
    1:
      RSA.KeyLength := kl3072;
  else
    RSA.KeyLength := kl4096;
  end;

  case ComboBox20.ItemIndex of
    0:
      begin
        RSA.OutputFormat := hexa;
        Conv.AType := hexa;
      end;
    1:
      begin
        RSA.OutputFormat := base64;
        Conv.AType := base64;
      end;
    2:
      begin
        RSA.OutputFormat := base64url;
        Conv.AType := base64url;
      end
  else
    begin
      RSA.OutputFormat := base32;
      Conv.AType := base32;
    end;
  end;

  RSA.Unicode := yesUni;
  RSA.Modulus := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit4.Text);
  RSA.PublicExponent := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit5.Text);
  RSA.PrivateExponent := Conv.KeyRSAOpenSSLToKeyTRSAEncSign(Edit6.Text);
  RSA.signType := TRSASignType(ComboBox33.ItemIndex);
  err := RSA.Verify(Memo5.Text, Memo6.Text);

  if err = 0 then
    Panel8.Color := clLime

end;

procedure TForm5.Image11Click(Sender: TObject);
begin

  case ComboBox4.ItemIndex of
    0:
      ECC.ECCType := cc25519;
    1:
      ECC.ECCType := cc448;
    2:
      ECC.ECCType := cc511187;
    3:
      ECC.ECCType := p256;
    4:
      ECC.ECCType := p384;
  else
    ECC.ECCType := p521;
  end;

  case ComboBox25.ItemIndex of
    0:
      ECC.OutputFormat := hexa;
    1:
      ECC.OutputFormat := base64;
    2:
      ECC.OutputFormat := base64url;
  else
    ECC.OutputFormat := base32;
  end;
  Conv.AType := ECC.OutputFormat;
  ECC.GenerateKeys;
  Edit7.Text := ECC.PublicKey;
  Edit8.Text := ECC.PrivateKey;

end;

procedure TForm5.Edit7Change(Sender: TObject);
var
  kl: Integer;
  keyOK1: Boolean;
begin
  case ComboBox4.ItemIndex of
    0:
      kl := 32;
    1:
      kl := 57;
    2:
      kl := 64;
    3:
      kl := 32;
    4:
      kl := 48;
  else
    kl := 66;
  end;

  case ComboBox25.ItemIndex of
    0:
      Conv.AType := hexa;
    1:
      Conv.AType := base64;
    2:
      Conv.AType := base64url;
  else
    Conv.AType := base32;
  end;

  if (ECC.ECCType = cc25519) or (ECC.ECCType = cc511187) or (ECC.ECCType = cc448)
  then
    keyOK1 := length(Edit7.Text) = Conv.OutputFormatLength(kl) - 1
  else
    keyOK1 := length(Edit7.Text) = Conv.OutputFormatLength(2 * kl + 1) - 1;

  if keyOK1 then
  begin
    Edit7.Color := clLime;
  end
  else
  begin
    Edit7.Color := clRed;
  end;

  Panel12.Enabled := keyOK1;
  Label31.Enabled := keyOK1;
  Image12.Enabled := keyOK1;

  Panel14.Enabled := keyOK1;
  Label35.Enabled := keyOK1;
  Image14.Enabled := keyOK1;

end;

procedure TForm5.Edit8Change(Sender: TObject);
var
  kl: Integer;
  keyOK2: Boolean;
begin
  case ComboBox4.ItemIndex of
    0:
      kl := 32;
    1:
      kl := 57;
    2:
      kl := 64;
    3:
      kl := 32;
    4:
      kl := 48;
  else
    kl := 66;
  end;

  case ComboBox25.ItemIndex of
    0:
      Conv.AType := hexa;
    1:
      Conv.AType := base64;
    2:
      Conv.AType := base64url;
  else
    Conv.AType := base32;
  end;

  keyOK2 := length(Edit8.Text) = Conv.OutputFormatLength(kl) - 1;

  if keyOK2 then
    Edit8.Color := clLime
  else
    Edit8.Color := clRed;

  Panel13.Enabled := keyOK2;
  Label32.Enabled := keyOK2;
  Image13.Enabled := keyOK2;

  Panel15.Enabled := keyOK2;
  Label36.Enabled := keyOK2;
  Image15.Enabled := keyOK2;

end;

procedure TForm5.Panel114Click(Sender: TObject);
begin
  case ComboBox37.ItemIndex of
    0:
      HKDF.OutputFormat := hexa;
    1:
      HKDF.OutputFormat := base64;
    2:
      HKDF.OutputFormat := base64url;
  else
    HKDF.OutputFormat := base32;
  end;

  case ComboBox38.ItemIndex of
    0:
      begin
        HKDF.hashFunction := hsha2;
        HKDF.HashSizeBits := 256;
      end;
    1:
      begin
        HKDF.hashFunction := hsha2;
        HKDF.HashSizeBits := 512;
      end;
    2:
      begin
        HKDF.hashFunction := hsha3;
        HKDF.HashSizeBits := 224;
      end;
    3:
      begin
        HKDF.hashFunction := hsha3;
        HKDF.HashSizeBits := 256;
      end;
    4:
      begin
        HKDF.hashFunction := hsha3;
        HKDF.HashSizeBits := 384;
      end
  else
    begin
      HKDF.hashFunction := hsha3;
      HKDF.HashSizeBits := 512;
    end
  end;

  Memo44.Text := HKDF.Expand(Memo46.Text, Memo43.Text, StrToInt(Edit94.Text));
end;

procedure TForm5.Panel115Click(Sender: TObject);
begin
  case ComboBox37.ItemIndex of
    0:
      HKDF.OutputFormat := hexa;
    1:
      HKDF.OutputFormat := base64;
    2:
      HKDF.OutputFormat := base64url;
  else
    HKDF.OutputFormat := base32;
  end;

  case ComboBox38.ItemIndex of
    0:
      begin
        HKDF.hashFunction := hsha2;
        HKDF.HashSizeBits := 256;
      end;
    1:
      begin
        HKDF.hashFunction := hsha2;
        HKDF.HashSizeBits := 512;
      end;
    2:
      begin
        HKDF.hashFunction := hsha3;
        HKDF.HashSizeBits := 224;
      end;
    3:
      begin
        HKDF.hashFunction := hsha3;
        HKDF.HashSizeBits := 256;
      end;
    4:
      begin
        HKDF.hashFunction := hsha3;
        HKDF.HashSizeBits := 384;
      end
  else
    begin
      HKDF.hashFunction := hsha3;
      HKDF.HashSizeBits := 512;
    end
  end;

  Memo46.Text := HKDF.Extract(Memo45.Text, Edit96.Text);
end;

procedure TForm5.Panel124Click(Sender: TObject);
var
  MyDirectory: string;
  MyList: TStringList;
  i: Integer;
begin
  tlsh.ShowVersion := CheckBox3.Checked;
  MyDirectory := Edit99.Text;
  MyList := TStringList.Create;
  Memo48.Clear;
  try
    if SearchAll(MyDirectory, '*.*', MyList) then
    begin
      for i := 0 to MyList.Count - 1 do
      begin
        Memo48.Lines.Add(MyList.Strings[i] + '::' +
          tlsh.GetHash(MyList.Strings[i]));
      end;
    end;
  finally
    MyList.Free;
  end;
end;

procedure TForm5.Panel125Click(Sender: TObject);
begin
  tlsh.ShowVersion := CheckBox3.Checked;
  Edit102.Text := tlsh.GetHash(Edit101.Text);
end;

procedure TForm5.Panel12Click(Sender: TObject);
begin
  case ComboBox4.ItemIndex of
    0:
      ECC.ECCType := cc25519;
    1:
      ECC.ECCType := cc448;
    2:
      ECC.ECCType := cc511187;
    3:
      ECC.ECCType := p256;
    4:
      ECC.ECCType := p384;
  else
    ECC.ECCType := p521;
  end;

  case ComboBox25.ItemIndex of
    0:
      ECC.OutputFormat := hexa;
    1:
      ECC.OutputFormat := base64;
    2:
      ECC.OutputFormat := base64url;
  else
    ECC.OutputFormat := base32;
  end;

  ECC.Unicode := yesUni;
  ECC.PublicKey := Edit7.Text;
  ECC.PrivateKey := Edit8.Text;
  Memo8.Text := ECC.Encrypt(Memo7.Text);
end;

procedure TForm5.Panel137Click(Sender: TObject);
begin
  InfoEdit.Text := inttostr(FileDistance(Edit100.Text, Edit98.Text, false));
end;

procedure TForm5.Panel13Click(Sender: TObject);
begin
  Memo7.Color := clGrayText;
  case ComboBox4.ItemIndex of
    0:
      ECC.ECCType := cc25519;
    1:
      ECC.ECCType := cc448;
    2:
      ECC.ECCType := cc511187;
    3:
      ECC.ECCType := p256;
    4:
      ECC.ECCType := p384;
  else
    ECC.ECCType := p521;
  end;

  case ComboBox25.ItemIndex of
    0:
      ECC.OutputFormat := hexa;
    1:
      ECC.OutputFormat := base64;
    2:
      ECC.OutputFormat := base64url;
  else
    ECC.OutputFormat := base32;
  end;

  ECC.Unicode := yesUni;
  ECC.PublicKey := Edit7.Text;
  ECC.PrivateKey := Edit8.Text;
  Memo7.Text := ECC.Decrypt(Memo8.Text);
  Refresh();
  sleep(30);
  Memo7.Color := clWindow;

end;

procedure TForm5.Panel14Click(Sender: TObject);
var
  err: Integer;
begin

  case ComboBox4.ItemIndex of
    0:
      ECC.ECCType := cc25519;
    1:
      ECC.ECCType := cc448;
    2:
      ECC.ECCType := cc511187;
    3:
      ECC.ECCType := p256;
    4:
      ECC.ECCType := p384;
  else
    ECC.ECCType := p521;
  end;

  case ComboBox25.ItemIndex of
    0:
      ECC.OutputFormat := hexa;
    1:
      ECC.OutputFormat := base64;
    2:
      ECC.OutputFormat := base64url;
  else
    ECC.OutputFormat := base32;
  end;

  ECC.Unicode := yesUni;
  ECC.PublicKey := Edit7.Text;
  ECC.PrivateKey := Edit8.Text;
  err := ECC.Verify(Memo9.Text, Memo10.Text);
  if err = 0 then
    Panel14.Color := clLime;

end;

procedure TForm5.Panel15Click(Sender: TObject);
begin
  Panel14.Color := clBtnHighlight;
  case ComboBox4.ItemIndex of
    0:
      ECC.ECCType := cc25519;
    1:
      ECC.ECCType := cc448;
    2:
      ECC.ECCType := cc511187;
    3:
      ECC.ECCType := p256;
    4:
      ECC.ECCType := p384;
  else
    ECC.ECCType := p521;
  end;

  case ComboBox25.ItemIndex of
    0:
      ECC.OutputFormat := hexa;
    1:
      ECC.OutputFormat := base64;
    2:
      ECC.OutputFormat := base64url;
  else
    ECC.OutputFormat := base32;
  end;

  ECC.Unicode := yesUni;
  ECC.PublicKey := Edit7.Text;
  ECC.PrivateKey := Edit8.Text;
  Memo10.Text := ECC.Sign(Memo9.Text);
end;

procedure TForm5.Edit94Change(Sender: TObject);
var
  keyOK: Boolean;
  i: Integer;
begin

  if TryStrToInt(Edit94.Text, i) and (i <= 255 * (HKDF.HashSizeBits div 8)) then
  begin
    Edit94.Color := clLime;
    keyOK := true;
  end
  else
  begin
    Edit94.Color := clRed;
    keyOK := false;
  end;

  Panel114.Enabled := keyOK;
  Label239.Enabled := keyOK;
  Image52.Enabled := keyOK;

end;

procedure TForm5.Edit99Change(Sender: TObject);
var
  fileEncOK: Boolean;
begin

  fileEncOK := (Edit99.Text <> '') and
    (System.SysUtils.DirectoryExists(Edit99.Text));

  Panel124.Enabled := fileEncOK;
  Label253.Enabled := fileEncOK;
  Image55.Enabled := fileEncOK;
end;

procedure TForm5.Edit9Change(Sender: TObject);
var
  kl: Integer;
  keyOK, fileEncOK, fileDecOK: Boolean;
begin
  case ComboBox6.ItemIndex of
    0:
      kl := 8;
    1:
      kl := 9;
    2:
      kl := 12;
    3:
      kl := 12;
    4:
      kl := 16;
    5:
      kl := 12;
    6:
      kl := 18;
    7:
      kl := 16;
    8:
      kl := 24;
  else
    kl := 32;
  end;

  Label39.Caption := '(' + inttostr(length(Edit9.Text)) + '/' +
    inttostr(kl) + ')';

  keyOK := length(Edit9.Text) = kl;

  fileEncOK := (Edit10.Text <> '') and (FileExists(Edit10.Text));

  fileDecOK := (Edit11.Text <> '') and (FileExists(Edit11.Text));

  if keyOK then
    Edit9.Color := clLime
  else
    Edit9.Color := clRed;

  Panel18.Enabled := keyOK;
  Panel17.Enabled := keyOK;
  Label42.Enabled := keyOK;
  Label43.Enabled := keyOK;
  Image17.Enabled := keyOK;
  Image18.Enabled := keyOK;

  Panel19.Enabled := keyOK and fileEncOK;
  Panel20.Enabled := keyOK and fileDecOK;
  Label46.Enabled := keyOK and fileEncOK;
  Label47.Enabled := keyOK and fileDecOK;
  Image19.Enabled := keyOK and fileEncOK;
  Image20.Enabled := keyOK and fileDecOK;
end;

procedure TForm5.Image16Click(Sender: TObject);
var
  s: string;
  kl: Integer;
begin
  case ComboBox6.ItemIndex of
    0:
      kl := 8;
    1:
      kl := 9;
    2:
      kl := 12;
    3:
      kl := 12;
    4:
      kl := 16;
    5:
      kl := 12;
    6:
      kl := 18;
    7:
      kl := 16;
    8:
      kl := 24;
  else
    kl := 32;
  end;

  // convert to hexa to display printable characters

  s := Conv.RandomString(kl div 2);
  Conv.AType := hexa;

  Edit9.Text := s;

end;

procedure TForm5.Panel18Click(Sender: TObject);
begin

  case ComboBox5.ItemIndex of
    0:
      SPECK.AType := stECB;
    1:
      SPECK.AType := stCBC;
  else
    SPECK.AType := stOFB;
  end;

  case ComboBox6.ItemIndex of
    0:
      begin
        SPECK.WordSizeBits := wsb16;
        SPECK.KeySizeWords := ksw4;
      end;
    1:
      begin
        SPECK.WordSizeBits := wsb24;
        SPECK.KeySizeWords := ksw3;
      end;
    2:
      begin
        SPECK.WordSizeBits := wsb24;
        SPECK.KeySizeWords := ksw4;
      end;
    3:
      begin
        SPECK.WordSizeBits := wsb32;
        SPECK.KeySizeWords := ksw3;
      end;
    4:
      begin
        SPECK.WordSizeBits := wsb32;
        SPECK.KeySizeWords := ksw4;
      end;
    5:
      begin
        SPECK.WordSizeBits := wsb48;
        SPECK.KeySizeWords := ksw2;
      end;
    6:
      begin
        SPECK.WordSizeBits := wsb48;
        SPECK.KeySizeWords := ksw3;
      end;
    7:
      begin
        SPECK.WordSizeBits := wsb64;
        SPECK.KeySizeWords := ksw2;
      end;
    8:
      begin
        SPECK.WordSizeBits := wsb64;
        SPECK.KeySizeWords := ksw3;
      end
  else
    begin
      SPECK.WordSizeBits := wsb64;
      SPECK.KeySizeWords := ksw4;
    end;
  end;

  case ComboBox18.ItemIndex of
    0:
      SPECK.OutputFormat := hexa;
    1:
      SPECK.OutputFormat := base64;
    2:
      SPECK.OutputFormat := base64url;
  else
    SPECK.OutputFormat := base32;
  end;

  SPECK.Key := Edit9.Text;

  SPECK.Unicode := yesUni;
  SPECK.PaddingMode := TSPECKPaddingMode.PKCS7;
  SPECK.IVMode := TSPECKIVMode.rand;

  Memo12.Text := SPECK.Encrypt(Memo11.Text);
end;

procedure TForm5.Panel17Click(Sender: TObject);
begin

  Memo11.Color := clGrayText;
  case ComboBox5.ItemIndex of
    0:
      SPECK.AType := stECB;
    1:
      SPECK.AType := stCBC;
  else
    SPECK.AType := stOFB;
  end;

  case ComboBox6.ItemIndex of
    0:
      begin
        SPECK.WordSizeBits := wsb16;
        SPECK.KeySizeWords := ksw4;
      end;
    1:
      begin
        SPECK.WordSizeBits := wsb24;
        SPECK.KeySizeWords := ksw3;
      end;
    2:
      begin
        SPECK.WordSizeBits := wsb24;
        SPECK.KeySizeWords := ksw4;
      end;
    3:
      begin
        SPECK.WordSizeBits := wsb32;
        SPECK.KeySizeWords := ksw3;
      end;
    4:
      begin
        SPECK.WordSizeBits := wsb32;
        SPECK.KeySizeWords := ksw4;
      end;
    5:
      begin
        SPECK.WordSizeBits := wsb48;
        SPECK.KeySizeWords := ksw2;
      end;
    6:
      begin
        SPECK.WordSizeBits := wsb48;
        SPECK.KeySizeWords := ksw3;
      end;
    7:
      begin
        SPECK.WordSizeBits := wsb64;
        SPECK.KeySizeWords := ksw2;
      end;
    8:
      begin
        SPECK.WordSizeBits := wsb64;
        SPECK.KeySizeWords := ksw3;
      end
  else
    begin
      SPECK.WordSizeBits := wsb64;
      SPECK.KeySizeWords := ksw4;
    end;
  end;

  case ComboBox18.ItemIndex of
    0:
      SPECK.OutputFormat := hexa;
    1:
      SPECK.OutputFormat := base64;
    2:
      SPECK.OutputFormat := base64url;
  else
    SPECK.OutputFormat := base32;
  end;

  SPECK.Key := Edit9.Text;

  SPECK.Unicode := yesUni;
  SPECK.PaddingMode := TSPECKPaddingMode.PKCS7;
  SPECK.IVMode := TSPECKIVMode.rand;

  Memo11.Text := SPECK.Decrypt(Memo12.Text);

  Refresh();
  sleep(30);
  Memo11.Color := clWindow;

end;

procedure TForm5.Panel19Click(Sender: TObject);
var
  s: string;
  f: Integer;
begin

  case ComboBox5.ItemIndex of
    0:
      SPECK.AType := stECB;
    1:
      SPECK.AType := stCBC;
  else
    SPECK.AType := stOFB;
  end;

  case ComboBox6.ItemIndex of
    0:
      begin
        SPECK.WordSizeBits := wsb16;
        SPECK.KeySizeWords := ksw4;
      end;
    1:
      begin
        SPECK.WordSizeBits := wsb24;
        SPECK.KeySizeWords := ksw3;
      end;
    2:
      begin
        SPECK.WordSizeBits := wsb24;
        SPECK.KeySizeWords := ksw4;
      end;
    3:
      begin
        SPECK.WordSizeBits := wsb32;
        SPECK.KeySizeWords := ksw3;
      end;
    4:
      begin
        SPECK.WordSizeBits := wsb32;
        SPECK.KeySizeWords := ksw4;
      end;
    5:
      begin
        SPECK.WordSizeBits := wsb48;
        SPECK.KeySizeWords := ksw2;
      end;
    6:
      begin
        SPECK.WordSizeBits := wsb48;
        SPECK.KeySizeWords := ksw3;
      end;
    7:
      begin
        SPECK.WordSizeBits := wsb64;
        SPECK.KeySizeWords := ksw2;
      end;
    8:
      begin
        SPECK.WordSizeBits := wsb64;
        SPECK.KeySizeWords := ksw3;
      end
  else
    begin
      SPECK.WordSizeBits := wsb64;
      SPECK.KeySizeWords := ksw4;
    end;
  end;

  SPECK.Key := Edit9.Text;

  SPECK.PaddingMode := TSPECKPaddingMode.PKCS7;
  SPECK.IVMode := TSPECKIVMode.rand;
  SPECK.Unicode := yesUni;
  SPECK.OnChange := SPECKOnChange;
  if FileExists(Edit10.Text) then
  begin
    if FileExists(Edit11.Text) then
      if Edit10.Text <> Edit11.Text then
        SPECK.EncryptFileW(Edit10.Text, Edit11.Text)
      else
        raise Exception.Create
          ('Impossible to encrypt the file in the same file')
    else
    begin
      if Edit11.Text = '' then
      begin
        s := Edit10.Text + '.enc';
        SPECK.EncryptFileW(Edit10.Text, s);
        Edit11.Text := s;
      end
      else
      begin
        f := FileCreate(Edit11.Text);
        if f <> -1 then
        begin
          FileClose(f);
          SPECK.EncryptFileW(Edit10.Text, Edit11.Text);
        end
        else
          raise Exception.Create('Impossible to create the output file');
      end;
    end;
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;
end;

procedure TForm5.Panel20Click(Sender: TObject);
var
  s: string;
  f: Integer;
begin
  case ComboBox5.ItemIndex of
    0:
      SPECK.AType := stECB;
    1:
      SPECK.AType := stCBC;
  else
    SPECK.AType := stOFB;
  end;

  case ComboBox6.ItemIndex of
    0:
      begin
        SPECK.WordSizeBits := wsb16;
        SPECK.KeySizeWords := ksw4;
      end;
    1:
      begin
        SPECK.WordSizeBits := wsb24;
        SPECK.KeySizeWords := ksw3;
      end;
    2:
      begin
        SPECK.WordSizeBits := wsb24;
        SPECK.KeySizeWords := ksw4;
      end;
    3:
      begin
        SPECK.WordSizeBits := wsb32;
        SPECK.KeySizeWords := ksw3;
      end;
    4:
      begin
        SPECK.WordSizeBits := wsb32;
        SPECK.KeySizeWords := ksw4;
      end;
    5:
      begin
        SPECK.WordSizeBits := wsb48;
        SPECK.KeySizeWords := ksw2;
      end;
    6:
      begin
        SPECK.WordSizeBits := wsb48;
        SPECK.KeySizeWords := ksw3;
      end;
    7:
      begin
        SPECK.WordSizeBits := wsb64;
        SPECK.KeySizeWords := ksw2;
      end;
    8:
      begin
        SPECK.WordSizeBits := wsb64;
        SPECK.KeySizeWords := ksw3;
      end
  else
    begin
      SPECK.WordSizeBits := wsb64;
      SPECK.KeySizeWords := ksw4;
    end;
  end;

  SPECK.Key := Edit9.Text;

  SPECK.PaddingMode := TSPECKPaddingMode.PKCS7;
  SPECK.IVMode := TSPECKIVMode.rand;
  SPECK.Unicode := yesUni;
  SPECK.OnChange := SPECKOnChange;
  if FileExists(Edit11.Text) then
  begin
    if FileExists(Edit10.Text) then
      if Edit10.Text <> Edit11.Text then
        SPECK.DecryptFileW(Edit11.Text, Edit10.Text)
      else
        raise Exception.Create
          ('Impossible to decrypt the file in the same file')
    else
    begin
      if Edit10.Text = '' then
      begin
        s := Edit11.Text + '.dec';
        SPECK.DecryptFileW(Edit11.Text, s);
        Edit10.Text := s;
      end
      else
      begin
        f := FileCreate(Edit10.Text);
        if f <> -1 then
        begin
          FileClose(f);
          SPECK.DecryptFileW(Edit11.Text, Edit10.Text);
        end
        else
          raise Exception.Create('Impossible to create the output file');
      end;
    end;
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;
end;

procedure TForm5.SpeedButton3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit10.Text := OpenDialog1.FileName;
    Edit9Change(Self);
  end;

end;

procedure TForm5.SpeedButton4Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit11.Text := OpenDialog1.FileName;
    Edit9Change(Self);
  end;
end;

procedure TForm5.ComboBox10Select(Sender: TObject);
begin
  if ComboBox10.ItemIndex = 0 then
  begin
    Label57.Visible := true;
    ComboBox7.Visible := true;
    Label70.Visible := false;
    Label71.Visible := false;
    ComboBox11.Visible := false;
    Edit15.Visible := false;
    Panel24.Enabled := true;
    Panel25.Enabled := true;
    Label64.Enabled := true;
    Label68.Enabled := true;
    Image24.Enabled := true;
    Image25.Enabled := true;
  end
  else
  begin
    Label70.Visible := true;
    Label71.Visible := true;
    ComboBox11.Visible := true;
    Edit15.Visible := true;
    Label57.Visible := false;
    ComboBox7.Visible := false;
    Panel24.Enabled := false;
    Panel25.Enabled := false;
    Label64.Enabled := false;
    Label68.Enabled := false;
    Image24.Enabled := false;
    Image25.Enabled := false;
  end;
end;

procedure TForm5.ComboBox20Select(Sender: TObject);
begin
  if ComboBox20.ItemIndex = 0 then
  begin
    if Combo20Item = 1 then
    begin
      Edit4.Text := Conv.Base64ToHexa(Edit4.Text);
      Edit5.Text := Conv.Base64ToHexa(Edit5.Text);
      Edit6.Text := Conv.Base64ToHexa(Edit6.Text);
    end
    else if Combo20Item = 2 then
    begin
      Edit4.Text := Conv.Base64urlToHexa(Edit4.Text);
      Edit5.Text := Conv.Base64urlToHexa(Edit5.Text);
      Edit6.Text := Conv.Base64urlToHexa(Edit6.Text);
    end
    else
    begin
      Edit4.Text := Conv.Base32ToHexa(Edit4.Text);
      Edit5.Text := Conv.Base32ToHexa(Edit5.Text);
      Edit6.Text := Conv.Base32ToHexa(Edit6.Text);
    end;
  end
  else if ComboBox20.ItemIndex = 1 then

  begin
    if Combo20Item = 0 then
    begin
      Edit4.Text := Conv.HexaToBase64(Edit4.Text);
      Edit5.Text := Conv.HexaToBase64(Edit5.Text);
      Edit6.Text := Conv.HexaToBase64(Edit6.Text);
    end
    else if Combo20Item = 2 then
    begin
      Edit4.Text := Conv.Base64urlToBase64(Edit4.Text);
      Edit5.Text := Conv.Base64urlToBase64(Edit5.Text);
      Edit6.Text := Conv.Base64urlToBase64(Edit6.Text);
    end
    else
    begin
      Edit4.Text := Conv.Base32ToBase64(Edit4.Text);
      Edit5.Text := Conv.Base32ToBase64(Edit5.Text);
      Edit6.Text := Conv.Base32ToBase64(Edit6.Text);
    end;
  end
  else if ComboBox20.ItemIndex = 2 then
  begin
    if Combo20Item = 0 then
    begin
      Edit4.Text := Conv.HexaToBase64url(Edit4.Text);
      Edit5.Text := Conv.HexaToBase64url(Edit5.Text);
      Edit6.Text := Conv.HexaToBase64url(Edit6.Text);
    end
    else if Combo20Item = 1 then
    begin
      Edit4.Text := Conv.Base64ToBase64url(Edit4.Text);
      Edit5.Text := Conv.Base64ToBase64url(Edit5.Text);
      Edit6.Text := Conv.Base64ToBase64url(Edit6.Text);
    end
    else
    begin
      Edit4.Text := Conv.Base32ToBase64url(Edit4.Text);
      Edit5.Text := Conv.Base32ToBase64url(Edit5.Text);
      Edit6.Text := Conv.Base32ToBase64url(Edit6.Text);
    end;

  end
  else
  begin
    if Combo20Item = 0 then
    begin
      Edit4.Text := Conv.HexaToBase32(Edit4.Text);
      Edit5.Text := Conv.HexaToBase32(Edit5.Text);
      Edit6.Text := Conv.HexaToBase32(Edit6.Text);
    end
    else if Combo20Item = 1 then
    begin
      Edit4.Text := Conv.Base64ToBase32(Edit4.Text);
      Edit5.Text := Conv.Base64ToBase32(Edit5.Text);
      Edit6.Text := Conv.Base64ToBase32(Edit6.Text);
    end
    else
    begin
      Edit4.Text := Conv.Base64urlToBase32(Edit4.Text);
      Edit5.Text := Conv.Base64urlToBase32(Edit5.Text);
      Edit6.Text := Conv.Base64urlToBase32(Edit6.Text);
    end;

  end;
  Combo20Item := ComboBox20.ItemIndex;
end;

procedure TForm5.ComboBox25Select(Sender: TObject);
begin
  if ComboBox25.ItemIndex = 0 then
  begin
    if Combo25Item = 1 then
    begin
      Edit7.Text := Conv.Base64ToHexa(Edit7.Text);
      Edit8.Text := Conv.Base64ToHexa(Edit8.Text);
    end
    else if Combo25Item = 2 then
    begin
      Edit7.Text := Conv.Base64urlToHexa(Edit7.Text);
      Edit8.Text := Conv.Base64urlToHexa(Edit8.Text);
    end
    else
    begin
      Edit7.Text := Conv.Base32ToHexa(Edit7.Text);
      Edit8.Text := Conv.Base32ToHexa(Edit8.Text);
    end;
  end
  else if ComboBox25.ItemIndex = 1 then
  begin
    if Combo25Item = 0 then
    begin
      Edit7.Text := Conv.HexaToBase64(Edit7.Text);
      Edit8.Text := Conv.HexaToBase64(Edit8.Text);
    end
    else if Combo25Item = 2 then
    begin
      Edit7.Text := Conv.Base64urlToBase64(Edit7.Text);
      Edit8.Text := Conv.Base64urlToBase64(Edit8.Text);
    end
    else
    begin
      Edit7.Text := Conv.Base32ToBase64(Edit7.Text);
      Edit8.Text := Conv.Base32ToBase64(Edit8.Text);
    end;
  end
  else if ComboBox25.ItemIndex = 2 then
  begin
    if Combo25Item = 0 then
    begin
      Edit7.Text := Conv.HexaToBase64url(Edit7.Text);
      Edit8.Text := Conv.HexaToBase64url(Edit8.Text);
    end
    else if Combo25Item = 1 then
    begin
      Edit7.Text := Conv.Base64ToBase64url(Edit7.Text);
      Edit8.Text := Conv.Base64ToBase64url(Edit8.Text);
    end
    else
    begin
      Edit7.Text := Conv.Base32ToBase64url(Edit7.Text);
      Edit8.Text := Conv.Base32ToBase64url(Edit8.Text);
    end;
  end
  else
  begin
    if Combo25Item = 0 then
    begin
      Edit7.Text := Conv.HexaToBase32(Edit7.Text);
      Edit8.Text := Conv.HexaToBase32(Edit8.Text);
    end
    else if Combo25Item = 1 then
    begin
      Edit7.Text := Conv.Base64ToBase32(Edit7.Text);
      Edit8.Text := Conv.Base64ToBase32(Edit8.Text);
    end
    else
    begin
      Edit7.Text := Conv.Base64urlToBase32(Edit7.Text);
      Edit8.Text := Conv.Base64urlToBase32(Edit8.Text);
    end;
  end;
  Combo25Item := ComboBox25.ItemIndex;
end;

procedure TForm5.ComboBox31Select(Sender: TObject);
begin
  if ComboBox31.ItemIndex < 2 then
  begin
    ComboBox32.Items.Clear;
    ComboBox32.Items.Add('2048');
    ComboBox32.Items.Add('4096');
    ComboBox32.Enabled := true;
    ComboBox28.Enabled := true;
  end
  else if ComboBox31.ItemIndex = 2 then
  begin
    ComboBox32.Items.Clear;
    ComboBox32.Items.Add('256');
    ComboBox32.Items.Add('384');
    ComboBox32.Items.Add('521');
    ComboBox32.Enabled := true;
    ComboBox28.Enabled := false;
  end
  else
  begin
    ComboBox32.Enabled := false;
    ComboBox28.Enabled := false;
  end;
end;

procedure TForm5.ComboBox33Select(Sender: TObject);
begin
  if ComboBox33.ItemIndex = 1 then
  begin
    RSA.encType := TRSAEncType.epkcs1_5;
    RSA.signType := TRSASignType.spkcs1_5;
  end
  else
  begin
    RSA.encType := TRSAEncType.oaep;
    RSA.signType := TRSASignType.pss;
  end;
end;

procedure TForm5.ComboBox35Select(Sender: TObject);
begin
  if ComboBox35.ItemIndex < 2 then
  begin
    ComboBox36.Items.Clear;
    ComboBox36.Items.Add('2048');
    ComboBox36.Items.Add('4096');
    ComboBox36.Enabled := true;
    ComboBox34.Enabled := true;
  end
  else if ComboBox35.ItemIndex = 2 then
  begin
    ComboBox36.Items.Clear;
    ComboBox36.Items.Add('256');
    ComboBox36.Items.Add('384');
    ComboBox36.Items.Add('521');
    ComboBox36.Enabled := true;
    ComboBox34.Enabled := false;
  end
  else
  begin
    ComboBox36.Enabled := false;
    ComboBox34.Enabled := false;
  end;
end;

procedure TForm5.ComboBox3Select(Sender: TObject);
begin
  Edit4Change(Sender);
  Edit6Change(Sender);
end;

procedure TForm5.ComboBox4Select(Sender: TObject);
begin
  Edit7Change(Sender);
  Edit8Change(Sender);
end;

/// /////////////////////////////////////////////////////////////////////////////
// SearchAll - recursively search all files in a directory
//
// paramaters:
// aPath	   - A directory to search.
// aPattern  - A file name pattern to use to find files (forced to *.*)
// aList     - to store all results (needs to be created prior to the call
//
/// /////////////////////////////////////////////////////////////////////////////
function TForm5.SearchAll(aPath: string; aPattern: string;
  aList: TStringList): Boolean;
var
  LocalPath: string;
  FileRecord: TSearchRec;
  FileAttrs: Integer;
  SubDirectories: Boolean;
  Separator: char;

begin
{$IFDEF MSWINDOWS}
  Separator := '\';
{$ELSE}
  Separator := '/';
{$ENDIF}
  SubDirectories := false;
  if (CompareStr(aPattern, '') <> 0) then
    aPattern := '*.*';

  if (aPath[length(aPath)] = Separator) then
    LocalPath := aPath + aPattern
  else
    LocalPath := aPath + Separator + aPattern;

  FileAttrs := faDirectory;
  if FindFirst(LocalPath, faAnyFile, FileRecord) = 0 then
  begin
    repeat
      if FileRecord.Attr and FileAttrs = FileAttrs then
      begin // subdirectory
        if System.String.Compare(FileRecord.Name, '.') <> 0 then
          if System.String.Compare(FileRecord.Name, '..') <> 0 then
            // ignore . and ..
            SubDirectories := true
      end
      else
      begin // file found
        // build full filename first
        if (aPath[length(aPath)] = Separator) then
          LocalPath := aPath + FileRecord.Name
        else
          LocalPath := aPath + Separator + FileRecord.Name;
        aList.Add(LocalPath);
      end;
    until FindNext(FileRecord) <> 0;
  end;

  if (SubDirectories = true) then
  begin // recursively parse the subs
    if (aPath[length(aPath)] = Separator) then
      LocalPath := aPath + aPattern
    else
      LocalPath := aPath + Separator + aPattern;

    if (FindFirst(LocalPath, faAnyFile, FileRecord) = 0) then
    begin
      repeat
        if FileRecord.Attr and FileAttrs = FileAttrs then
        begin // subdirectory
          // ignore . and ..
          if System.String.Compare(FileRecord.Name, '.') <> 0 then
            if System.String.Compare(FileRecord.Name, '..') <> 0 then
              if aPath[length(aPath)] = '\' then
                LocalPath := aPath + FileRecord.Name
              else
                LocalPath := aPath + Separator + FileRecord.Name;

          if (SearchAll(LocalPath, aPattern, aList) = false) then
          begin
            Result := false; // error return
            exit;
          end;
        end;
      until FindNext(FileRecord) <> 0;
    end;
  end;
  FindClose(FileRecord);
  Result := true;
end;

procedure TForm5.Edit100Change(Sender: TObject);
var
  fileEncOK: Boolean;
begin

  fileEncOK := (Edit100.Text <> '') and (FileExists(Edit100.Text)) and
    (Edit98.Text <> '') and (FileExists(Edit98.Text));

  Panel137.Enabled := fileEncOK;
  Label244.Enabled := fileEncOK;
  Image54.Enabled := fileEncOK;
end;

procedure TForm5.Edit101Change(Sender: TObject);
var
  fileEncOK: Boolean;
begin

  fileEncOK := (Edit101.Text <> '') and (FileExists(Edit101.Text));

  Panel125.Enabled := fileEncOK;
  Label256.Enabled := fileEncOK;
  Image56.Enabled := fileEncOK;
end;

procedure TForm5.Edit12Change(Sender: TObject);
var
  kl: Integer;
  keyOK, fileEncOK, fileDecOK: Boolean;
begin
  case ComboBox8.ItemIndex of
    0:
      kl := 16;
  else
    kl := 32;
  end;

  Label51.Caption := '(' + inttostr(length(Edit12.Text)) + '/' +
    inttostr(kl) + ')';

  keyOK := length(Edit12.Text) = kl;

  fileEncOK := (Edit35.Text <> '') and (FileExists(Edit35.Text));

  fileDecOK := (Edit36.Text <> '') and (FileExists(Edit36.Text));

  if keyOK then
    Edit12.Color := clLime
  else
    Edit12.Color := clRed;

  Panel22.Enabled := keyOK;
  Panel23.Enabled := keyOK;
  Label55.Enabled := keyOK;
  Label54.Enabled := keyOK;
  Image22.Enabled := keyOK;
  Image23.Enabled := keyOK;

  Panel49.Enabled := keyOK and fileEncOK;
  Panel50.Enabled := keyOK and fileDecOK;
  Label159.Enabled := keyOK and fileEncOK;
  Label160.Enabled := keyOK and fileDecOK;
  Image49.Enabled := keyOK and fileEncOK;
  Image50.Enabled := keyOK and fileDecOK;

end;

procedure TForm5.Edit13Change(Sender: TObject);
var
  fileEncOK: Boolean;
begin

  fileEncOK := (Edit13.Text <> '') and (FileExists(Edit13.Text));

  Panel25.Enabled := fileEncOK;
  Label68.Enabled := fileEncOK;
  Image25.Enabled := fileEncOK;
end;

procedure TForm5.Edit14Change(Sender: TObject);
var
  fileEncOK: Boolean;
begin

  fileEncOK := (Edit14.Text <> '') and (FileExists(Edit14.Text));

  Panel27.Enabled := fileEncOK;
  Label65.Enabled := fileEncOK;
  Image27.Enabled := fileEncOK;
end;

procedure TForm5.Edit15Change(Sender: TObject);
var
  i: Integer;
  keyOK, fileEncOK: Boolean;
begin
  if ComboBox10.ItemIndex = 1 then
  begin
    if TryStrToInt(Edit15.Text, i) then
    begin
      Edit15.Color := clLime;
      keyOK := true;
    end
    else
    begin
      Edit15.Color := clRed;
      keyOK := false;
    end;

    fileEncOK := (Edit13.Text <> '') and (FileExists(Edit13.Text));

    Panel24.Enabled := keyOK;
    Panel25.Enabled := keyOK and fileEncOK;
    Label64.Enabled := keyOK;
    Label68.Enabled := keyOK and fileEncOK;
    Image24.Enabled := keyOK;
    Image25.Enabled := keyOK and fileEncOK;

  end;

end;

procedure TForm5.Image21Click(Sender: TObject);
var
  s: string;
  kl: Integer;
begin
  case ComboBox8.ItemIndex of
    0:
      kl := 16;
  else
    kl := 32;
  end;

  // convert to hexa to display printable characters
  Conv.AType := hexa;
  s := Conv.RandomString(kl div 2);

  Edit12.Text := s;

end;

procedure TForm5.Panel23Click(Sender: TObject);
begin

  case ComboBox8.ItemIndex of
    0:
      Salsa.KeyLength := skl128;
  else
    Salsa.KeyLength := skl256;
  end;

  case ComboBox19.ItemIndex of
    0:
      Salsa.OutputFormat := hexa;
    1:
      Salsa.OutputFormat := base64;
    2:
      Salsa.OutputFormat := base64url;
  else
    Salsa.OutputFormat := base32;
  end;

  Salsa.Key := Edit12.Text;
  Salsa.Unicode := yesUni;

  Memo14.Text := Salsa.Encrypt(Memo13.Text);
end;

procedure TForm5.Panel22Click(Sender: TObject);
begin

  Memo13.Color := clGrayText;
  case ComboBox8.ItemIndex of
    0:
      Salsa.KeyLength := skl128;
  else
    Salsa.KeyLength := skl256;
  end;

  case ComboBox19.ItemIndex of
    0:
      Salsa.OutputFormat := hexa;
    1:
      Salsa.OutputFormat := base64;
    2:
      Salsa.OutputFormat := base64url;
  else
    Salsa.OutputFormat := base32;
  end;

  Salsa.Key := Edit12.Text;
  Salsa.Unicode := yesUni;

  Memo13.Text := Salsa.Decrypt(Memo14.Text);

  Refresh();
  sleep(30);
  Memo13.Color := clWindow;

end;

procedure TForm5.Panel26Click(Sender: TObject);
begin

  case ComboBox9.ItemIndex of
    0:
      SHA2.HashSizeBits := 256;
    1:
      SHA2.HashSizeBits := 384;
  else
    SHA2.HashSizeBits := 512;
  end;

  case ComboBox21.ItemIndex of
    0:
      SHA2.OutputFormat := hexa;
    1:
      SHA2.OutputFormat := base64;
    2:
      SHA2.OutputFormat := base64url;
  else
    SHA2.OutputFormat := base32;
  end;

  SHA2.Unicode := yesUni;
  Memo16.Text := SHA2.Hash(Memo15.Text);
end;

procedure TForm5.SpeedButton5Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit14.Text := OpenDialog1.FileName;
  end;

end;

procedure TForm5.SpeedButton6Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit13.Text := OpenDialog1.FileName;
  end;

end;

procedure TForm5.Panel27Click(Sender: TObject);
var
  s: string;
begin

  case ComboBox9.ItemIndex of
    0:
      SHA2.HashSizeBits := 256;
    1:
      SHA2.HashSizeBits := 384;
  else
    SHA2.HashSizeBits := 512;
  end;

  case ComboBox21.ItemIndex of
    0:
      SHA2.OutputFormat := hexa;
    1:
      SHA2.OutputFormat := base64;
    2:
      SHA2.OutputFormat := base64url;
  else
    SHA2.OutputFormat := base32;
  end;

  SHA2.Unicode := yesUni;
  SHA2.OnChange := SHA2OnChange;
  if FileExists(Edit14.Text) then
  begin
    s := SHA2.HashFile(Edit14.Text);
    Memo17.Text := s;
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;

end;

procedure TForm5.Panel24Click(Sender: TObject);
begin
  if ComboBox10.ItemIndex = 0 then
    SHA3.AType := tsha
  else
    SHA3.AType := txof;

  case ComboBox22.ItemIndex of
    0:
      SHA3.OutputFormat := hexa;
    1:
      SHA3.OutputFormat := base64;
    2:
      SHA3.OutputFormat := base64url;
  else
    SHA3.OutputFormat := base32;
  end;

  case SHA3.AType of
    tsha:
      begin
        case ComboBox7.ItemIndex of
          0:
            SHA3.HashSizeBits := 224;
          1:
            SHA3.HashSizeBits := 256;
          2:
            SHA3.HashSizeBits := 384;
        else
          SHA3.HashSizeBits := 512;
        end;
      end;
    txof:
      begin
        SHA3.HashSizeBits := StrToInt(Edit15.Text) * 8;
      end;
  end;

  case ComboBox11.ItemIndex of
    0:
      SHA3.version := 256;
  else
    SHA3.version := 512;
  end;

  SHA3.Unicode := yesUni;
  Memo19.Text := SHA3.Hash(Memo18.Text);

end;

procedure TForm5.Panel25Click(Sender: TObject);
var
  s: string;
begin

  if ComboBox10.ItemIndex = 0 then
    SHA3.AType := tsha
  else
    SHA3.AType := txof;

  case ComboBox22.ItemIndex of
    0:
      SHA3.OutputFormat := hexa;
    1:
      SHA3.OutputFormat := base64;
    2:
      SHA3.OutputFormat := base64url;
  else
    SHA3.OutputFormat := base32;
  end;

  case SHA3.AType of
    tsha:
      begin
        case ComboBox7.ItemIndex of
          0:
            SHA3.HashSizeBits := 224;
          1:
            SHA3.HashSizeBits := 256;
          2:
            SHA3.HashSizeBits := 384;
        else
          SHA3.HashSizeBits := 512;
        end;
      end;
    txof:
      begin
        SHA3.HashSizeBits := StrToInt(Edit15.Text) * 8;
      end;
  end;

  case ComboBox11.ItemIndex of
    0:
      SHA3.version := 256;
  else
    SHA3.version := 512;
  end;

  SHA3.Unicode := yesUni;
  SHA3.OnChange := SHA3OnChange;
  if FileExists(Edit13.Text) then
  begin
    s := SHA3.HashFile(Edit13.Text);
    Memo20.Text := s;
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;
end;

procedure TForm5.Edit18Change(Sender: TObject);
var
  keyOK, keyOK1, keyOK2: Boolean;
  i: Integer;
begin

  if TryStrToInt(Edit17.Text, i) then
  begin
    Edit17.Color := clLime;
    keyOK2 := true;
  end
  else
  begin
    Edit17.Color := clRed;
    keyOK2 := false;
  end;

  if TryStrToInt(Edit16.Text, i) then
  begin
    Edit16.Color := clLime;
    keyOK1 := true;
  end
  else
  begin
    Edit16.Color := clRed;
    keyOK1 := false;
  end;

  keyOK := keyOK1 and keyOK2;

  Panel28.Enabled := keyOK;
  Label78.Enabled := keyOK;
  Image28.Enabled := keyOK;

end;

procedure TForm5.Image29Click(Sender: TObject);
var
  s: string;
begin
  // convert to hexa to display printable characters
  Conv.AType := hexa;
  s := Conv.RandomString(30);

  Edit18.Text := s;

end;

procedure TForm5.Panel28Click(Sender: TObject);
begin

  case ComboBox23.ItemIndex of
    0:
      PBKDF2.OutputFormat := hexa;
    1:
      PBKDF2.OutputFormat := base64;
    2:
      PBKDF2.OutputFormat := base64url;
  else
    PBKDF2.OutputFormat := base32;
  end;

  case ComboBox26.ItemIndex of
    0:
      begin
        PBKDF2.hashFunction := hsha2;
        PBKDF2.HashSizeBits := 256;
      end;
    1:
      begin
        PBKDF2.hashFunction := hsha2;
        PBKDF2.HashSizeBits := 512;
      end;
    2:
      begin
        PBKDF2.hashFunction := hsha3;
        PBKDF2.HashSizeBits := 224;
      end;
    3:
      begin
        PBKDF2.hashFunction := hsha3;
        PBKDF2.HashSizeBits := 256;
      end;
    4:
      begin
        PBKDF2.hashFunction := hsha3;
        PBKDF2.HashSizeBits := 384;
      end
  else
    begin
      PBKDF2.hashFunction := hsha3;
      PBKDF2.HashSizeBits := 512;
    end
  end;
  PBKDF2.OutputSizeBits := StrToInt(Edit16.Text) * 8;
  PBKDF2.Counter := StrToInt(Edit17.Text);
  PBKDF2.Salt := Edit18.Text;
  PBKDF2.Unicode := yesUni;

  Memo22.Text := PBKDF2.GenerateKey(Memo21.Text);
end;

procedure TForm5.Edit19Change(Sender: TObject);
var
  kl: Integer;
  keyOK, fileEncOK, keyOK1: Boolean;
begin

  if TryStrToInt(Edit21.Text, kl) then
  begin
    if kl <= 16 then
    begin
      keyOK1 := true
    end
    else
      keyOK1 := false;
  end
  else
    keyOK1 := false;

  if keyOK1 then
    Edit21.Color := clLime
  else
    Edit21.Color := clRed;

  case ComboBox13.ItemIndex of
    0:
      kl := 16;
    1:
      kl := 24;
  else
    kl := 32;
  end;

  Label82.Caption := '(' + inttostr(length(Edit19.Text)) + '/' +
    inttostr(kl) + ')';

  keyOK := length(Edit19.Text) = kl;

  fileEncOK := (Edit20.Text <> '') and (FileExists(Edit20.Text));

  if keyOK then
    Edit19.Color := clLime
  else
    Edit19.Color := clRed;

  keyOK := keyOK and keyOK1;

  Panel32.Enabled := keyOK;
  Label86.Enabled := keyOK;
  Image32.Enabled := keyOK;
  Panel31.Enabled := keyOK;
  Label85.Enabled := keyOK;
  Image31.Enabled := keyOK;

  Panel33.Enabled := keyOK and fileEncOK;
  Label89.Enabled := keyOK and fileEncOK;
  Image33.Enabled := keyOK and fileEncOK;
  Panel34.Enabled := keyOK and fileEncOK;
  Label88.Enabled := keyOK and fileEncOK;
  Image34.Enabled := keyOK and fileEncOK;
end;

procedure TForm5.Panel32Click(Sender: TObject);
begin
  Panel31.Color := clBtnHighlight;

  case ComboBox13.ItemIndex of
    0:
      AESMAC.KeyLength := kl128;
    1:
      AESMAC.KeyLength := kl192;
  else
    AESMAC.KeyLength := kl256;
  end;

  case ComboBox16.ItemIndex of
    0:
      AESMAC.OutputFormat := hexa;
    1:
      AESMAC.OutputFormat := base64;
    2:
      AESMAC.OutputFormat := base64url;
  else
    AESMAC.OutputFormat := base32;
  end;

  AESMAC.Unicode := yesUni;
  AESMAC.Key := Edit19.Text;
  AESMAC.TagSizeBits := StrToInt(Edit21.Text) * 8;
  Memo24.Text := AESMAC.Generate(Memo23.Text);

end;

procedure TForm5.Panel31Click(Sender: TObject);
var
  err: Integer;
begin
  case ComboBox13.ItemIndex of
    0:
      AESMAC.KeyLength := kl128;
    1:
      AESMAC.KeyLength := kl192;
  else
    AESMAC.KeyLength := kl256;
  end;

  case ComboBox16.ItemIndex of
    0:
      AESMAC.OutputFormat := hexa;
    1:
      AESMAC.OutputFormat := base64;
    2:
      AESMAC.OutputFormat := base64url;
  else
    AESMAC.OutputFormat := base32;
  end;

  AESMAC.Key := Edit19.Text;

  AESMAC.Unicode := yesUni;
  AESMAC.TagSizeBits := StrToInt(Edit21.Text) * 8;

  err := AESMAC.Verify(Memo23.Text, Memo24.Text);

  if err = 0 then
  begin
    Panel31.Color := clLime;
  end
  else
  begin
    Panel31.Color := clBtnHighlight;
  end;

end;

procedure TForm5.Panel33Click(Sender: TObject);
var
  s: string;
begin
  Panel31.Color := clBtnHighlight;
  case ComboBox13.ItemIndex of
    0:
      AESMAC.KeyLength := kl128;
    1:
      AESMAC.KeyLength := kl192;
  else
    AESMAC.KeyLength := kl256;
  end;

  case ComboBox16.ItemIndex of
    0:
      AESMAC.OutputFormat := hexa;
    1:
      AESMAC.OutputFormat := base64;
    2:
      AESMAC.OutputFormat := base64url;
  else
    AESMAC.OutputFormat := base32;
  end;

  AESMAC.Key := Edit19.Text;
  AESMAC.TagSizeBits := StrToInt(Edit21.Text) * 8;
  AESMAC.Unicode := yesUni;
  AESMAC.OnChange := AESMACOnChange;
  if FileExists(Edit20.Text) then
  begin
    s := AESMAC.GenerateFromFile(Edit20.Text);
    Memo25.Text := s;
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;

end;

procedure TForm5.Panel34Click(Sender: TObject);
var
  err: Integer;
begin
  case ComboBox13.ItemIndex of
    0:
      AESMAC.KeyLength := kl128;
    1:
      AESMAC.KeyLength := kl192;
  else
    AESMAC.KeyLength := kl256;
  end;

  case ComboBox16.ItemIndex of
    0:
      AESMAC.OutputFormat := hexa;
    1:
      AESMAC.OutputFormat := base64;
    2:
      AESMAC.OutputFormat := base64url;
  else
    AESMAC.OutputFormat := base32;
  end;

  AESMAC.Key := Edit19.Text;
  AESMAC.TagSizeBits := StrToInt(Edit21.Text) * 8;
  AESMAC.Unicode := yesUni;
  AESMAC.OnChange := AESMACOnChange;
  if FileExists(Edit20.Text) then
  begin
    err := AESMAC.VerifyFromFile(Edit20.Text, Memo25.Text);
  end
  else
  begin
    raise Exception.Create('The file does not exist !');
  end;
  if err = 0 then
  begin
    Panel34.Color := clLime;
  end
  else
  begin
    Panel34.Color := clBtnHighlight;
    raise Exception.Create('The tag is not the right one!');
  end;

end;

procedure TForm5.Edit22Change(Sender: TObject);
var
  kl: Integer;
  keyOK, keyOK1, fileEncOK, fileDecOK, fileTagOK: Boolean;
begin
  if TryStrToInt(Edit23.Text, kl) then
  begin
    if kl <= 16 then
    begin
      keyOK1 := true;
    end
    else
      keyOK1 := false;
  end
  else
    keyOK1 := false;

  if keyOK1 then
    Edit23.Color := clLime
  else
    Edit23.Color := clRed;

  case ComboBox12.ItemIndex of
    0:
      kl := 16;
    1:
      kl := 24;
  else
    kl := 32;
  end;

  Label93.Caption := '(' + inttostr(length(Edit22.Text)) + '/' +
    inttostr(kl) + ')';

  keyOK := length(Edit22.Text) = kl;

  fileEncOK := (Edit24.Text <> '') and (FileExists(Edit24.Text));

  fileDecOK := (Edit25.Text <> '') and (FileExists(Edit25.Text));

  fileTagOK := (Edit26.Text <> '') and (FileExists(Edit26.Text));

  if keyOK then
    Edit22.Color := clLime
  else
    Edit22.Color := clRed;

  keyOK := keyOK and keyOK1;

  Panel36.Enabled := keyOK;
  Label97.Enabled := keyOK;
  Image36.Enabled := keyOK;
  Panel37.Enabled := keyOK;
  Label98.Enabled := keyOK;
  Image37.Enabled := keyOK;

  Panel38.Enabled := keyOK and fileEncOK;
  Label101.Enabled := keyOK and fileEncOK;
  Image38.Enabled := keyOK and fileEncOK;
  Panel39.Enabled := keyOK and fileDecOK and fileTagOK;
  Label102.Enabled := keyOK and fileEncOK and fileTagOK;
  Image39.Enabled := keyOK and fileEncOK and fileTagOK;
end;

procedure TForm5.Edit27Change(Sender: TObject);
var
  keyOK, keyOK1, fileEncOK: Boolean;
  i: Integer;
begin
  if TryStrToInt(Edit28.Text, i) then
  begin
    if i > 64 then
      keyOK1 := false
    else
      keyOK1 := true;
  end
  else
  begin
    keyOK1 := false;
  end;

  if keyOK1 then
    Edit28.Color := clLime
  else
    Edit28.Color := clRed;

  Label131.Caption := '(' + inttostr(length(Edit27.Text)) + '/64)';

  keyOK := length(Edit27.Text) < 65;

  fileEncOK := (Edit29.Text <> '') and (FileExists(Edit29.Text));

  if keyOK then
    Edit27.Color := clLime
  else
    Edit27.Color := clRed;

  keyOK := keyOK and keyOK1;

  Panel43.Enabled := keyOK;
  Label137.Enabled := keyOK;
  Image43.Enabled := keyOK;

  Panel44.Enabled := keyOK and fileEncOK;
  Label140.Enabled := keyOK and fileEncOK;
  Image44.Enabled := keyOK and fileEncOK;
end;

procedure TForm5.Edit30Change(Sender: TObject);
var
  fileEncOK: Boolean;
begin

  fileEncOK := (Edit30.Text <> '') and (FileExists(Edit30.Text));

  Panel46.Enabled := fileEncOK;
  Label148.Enabled := fileEncOK;
  Image46.Enabled := fileEncOK;
end;

procedure TForm5.Edit33Change(Sender: TObject);
var
  keyOK, keyOK1, keyOK2, keyOK3: Boolean;
  i: Integer;
begin

  if TryStrToInt(Edit31.Text, i) then
  begin
    Edit31.Color := clLime;
    keyOK1 := true;
  end
  else
  begin
    Edit31.Color := clRed;
    keyOK1 := false;
  end;

  if TryStrToInt(Edit32.Text, i) then
  begin
    if i < 1 then
    begin
      Edit32.Color := clRed;
      keyOK2 := false;
    end
    else
    begin
      Edit32.Color := clLime;
      keyOK2 := true;
    end;
  end
  else
  begin
    Edit32.Color := clRed;
    keyOK2 := false;
  end;

  if TryStrToInt(Edit34.Text, i) then
  begin
    if i < 8 then
    begin
      Edit34.Color := clRed;
      keyOK3 := false;
    end
    else
    begin
      Edit34.Color := clLime;
      keyOK3 := true;
    end;
  end
  else
  begin
    Edit34.Color := clRed;
    keyOK3 := false;
  end;

  Label152.Caption := '(' + inttostr(length(Edit33.Text)) + '/16)';

  keyOK := length(Edit33.Text) = 16;

  if keyOK then
    Edit33.Color := clLime
  else
    Edit33.Color := clRed;

  keyOK := keyOK and keyOK1 and keyOK2 and keyOK3;

  Panel48.Enabled := keyOK;
  Label157.Enabled := keyOK;
  Image48.Enabled := keyOK;

end;

procedure TForm5.Image35Click(Sender: TObject);
var
  s: string;
  kl: Integer;
begin
  case ComboBox12.ItemIndex of
    0:
      kl := 16;
    1:
      kl := 24;
  else
    kl := 32;
  end;

  // convert to hexa to display printable characters
  Conv.AType := hexa;
  s := Conv.RandomString(kl div 2);

  Edit22.Text := s;

end;

procedure TForm5.Image42Click(Sender: TObject);
var
  s: string;
begin
  s := '';
  // convert to hexa to display printable characters
  Conv.AType := hexa;
  s := Conv.RandomString(32);

  Edit27.Text := s;

end;

procedure TForm5.Image47Click(Sender: TObject);
var
  s: string;
begin
  // convert to hexa to display printable characters
  Conv.AType := hexa;
  s := Conv.RandomString(8);

  Edit33.Text := s;

end;

procedure TForm5.Panel36Click(Sender: TObject);
var
  output: string;
begin
  Panel37.Color := clBtnHighlight;
  AESGCM.TagSizeBits := StrToInt(Edit23.Text) * 8;

  case ComboBox12.ItemIndex of
    0:
      AESGCM.KeyLength := kl128;
    1:
      AESGCM.KeyLength := kl192;
  else
    AESGCM.KeyLength := kl256;
  end;

  case ComboBox17.ItemIndex of
    0:
      AESGCM.OutputFormat := hexa;
    1:
      AESGCM.OutputFormat := base64;
    2:
      AESGCM.OutputFormat := base64url;
  else
    AESGCM.OutputFormat := base32;
  end;

  AESGCM.Key := Edit22.Text;

  AESGCM.Unicode := yesUni;
  AESGCM.IVMode := TIVMode.rand;

  output := AESGCM.EncryptAndGenerate(Memo26.Text, '');

  Memo29.Text := output.Substring
    (Conv.OutputFormatLength(AESGCM.TagSizeBits DIV 8) - 1,
    length(output) - Conv.OutputFormatLength(AESGCM.TagSizeBits DIV 8) + 1);

  Memo27.Text := output.Substring(0,
    Conv.OutputFormatLength(AESGCM.TagSizeBits DIV 8) - 1);

end;

procedure TForm5.Panel37Click(Sender: TObject);
var
  input: string;
  s1, s2, o: string;
  err: Integer;
begin
  Memo26.Color := clGrayText;
  AESGCM.TagSizeBits := StrToInt(Edit23.Text) * 8;

  case ComboBox12.ItemIndex of
    0:
      AESGCM.KeyLength := kl128;
    1:
      AESGCM.KeyLength := kl192;
  else
    AESGCM.KeyLength := kl256;
  end;

  case ComboBox17.ItemIndex of
    0:
      AESGCM.OutputFormat := hexa;
    1:
      AESGCM.OutputFormat := base64;
    2:
      AESGCM.OutputFormat := base64url;
  else
    AESGCM.OutputFormat := base32;
  end;

  AESGCM.Key := Edit22.Text;

  AESGCM.Unicode := yesUni;
  AESGCM.IVMode := TIVMode.rand;

  s1 := Memo29.Text;
  s2 := Memo27.Text;
  input := s2 + s1;

  o := Memo26.Text;
  err := AESGCM.DecryptAndVerify(input, '', o);
  Memo26.Text := o;
  if err = 0 then
    Panel37.Color := clLime;

  Refresh();
  sleep(30);
  Memo26.Color := clWindow;

end;

procedure TForm5.Panel38Click(Sender: TObject);
var
  f: Integer;
  s, s2: string;
begin
  Panel39.Color := clBtnHighlight;

  AESGCM.TagSizeBits := StrToInt(Edit23.Text) * 8;

  case ComboBox12.ItemIndex of
    0:
      AESGCM.KeyLength := kl128;
    1:
      AESGCM.KeyLength := kl192;
  else
    AESGCM.KeyLength := kl256;
  end;

  AESGCM.Key := Edit22.Text;

  AESGCM.IVMode := TIVMode.rand;
  AESGCM.Unicode := yesUni;
  AESGCM.OnChange := AESGCMOnChange;
  if FileExists(Edit24.Text) then
  begin
    if FileExists(Edit25.Text) then
    begin
      if FileExists(Edit26.Text) then
      begin
        if (Edit24.Text <> Edit25.Text) then
          AESGCM.EncryptAndGenerateFromFile(Edit24.Text, Edit25.Text, '',
            Edit26.Text)
        else
          raise Exception.Create
            ('The encrypted file must be different from the plain text file');
      end
      else
      begin
        if Edit26.Text <> '' then
        begin
          f := FileCreate(Edit26.Text);
          if f <> -1 then
          begin
            FileClose(f);
            AESGCM.EncryptAndGenerateFromFile(Edit24.Text, Edit25.Text, '',
              Edit26.Text);
          end
          else
            raise Exception.Create('Impossible to create the file ' +
              Edit26.Text);
        end
        else
        begin
          s := Edit24.Text + '.tag';
          AESGCM.EncryptAndGenerateFromFile(Edit24.Text, Edit25.Text, '', s);
          Edit26.Text := s;

        end;
      end;
    end
    else
    begin
      if Edit25.Text <> '' then
      begin
        f := FileCreate(Edit25.Text);
        if f <> -1 then
        begin
          FileClose(f);
          if FileExists(Edit26.Text) then
          begin
            AESGCM.EncryptAndGenerateFromFile(Edit24.Text, Edit25.Text, '',
              Edit26.Text);
          end
          else
          begin
            if Edit26.Text <> '' then
            begin
              f := FileCreate(Edit26.Text);
              if f <> -1 then
              begin
                FileClose(f);
                AESGCM.EncryptAndGenerateFromFile(Edit24.Text, Edit25.Text, '',
                  Edit26.Text);
              end
              else
                raise Exception.Create('Impossible to create the file ' +
                  Edit26.Text);
            end
            else
            begin
              s := Edit24.Text + '.tag';
              AESGCM.EncryptAndGenerateFromFile(Edit24.Text,
                Edit25.Text, '', s);
              Edit26.Text := s;

            end;
          end;
        end
        else
          raise Exception.Create('Impossible to create the file ' +
            Edit25.Text);
      end
      else
      begin
        s := Edit24.Text + '.enc';
        if FileExists(Edit26.Text) then
        begin
          AESGCM.EncryptAndGenerateFromFile(Edit24.Text, s, '', Edit26.Text);
        end
        else
        begin
          if Edit26.Text <> '' then
          begin
            f := FileCreate(Edit26.Text);
            if f <> -1 then
            begin
              FileClose(f);
              AESGCM.EncryptAndGenerateFromFile(Edit24.Text, s, '',
                Edit26.Text);
            end
            else
              raise Exception.Create('Impossible to create the file ' +
                Edit26.Text);
          end
          else
          begin
            s2 := Edit24.Text + '.tag';
            AESGCM.EncryptAndGenerateFromFile(Edit24.Text, s, '', s2);
            Edit26.Text := s2;

          end;
        end;
        Edit25.Text := s;
      end;
    end;
  end
  else
    raise Exception.Create('The file ' + Edit24.Text + 'does not exist!');

end;

procedure TForm5.Panel39Click(Sender: TObject);
var
  err: Integer;
  s: string;
  f: Integer;
begin
  case ComboBox12.ItemIndex of
    0:
      AESGCM.KeyLength := kl128;
    1:
      AESGCM.KeyLength := kl192;
  else
    AESGCM.KeyLength := kl256;
  end;

  AESGCM.Key := Edit22.Text;
  AESGCM.TagSizeBits := StrToInt(Edit23.Text) * 8;
  AESGCM.IVMode := TIVMode.rand;
  AESGCM.Unicode := yesUni;
  AESGCM.OnChange := AESGCMOnChange;
  if FileExists(Edit25.Text) then
  begin
    if FileExists(Edit26.Text) then
    begin
      if FileExists(Edit24.Text) then
      begin
        if Edit25.Text <> Edit24.Text then
          err := AESGCM.DecryptAndVerifyFromFile(Edit25.Text, Edit24.Text, '',
            Edit26.Text)
        else
          raise Exception.Create
            ('The decrypted file must be different from the encrypted file');
      end
      else
      begin
        if Edit24.Text <> '' then
        begin
          f := FileCreate(Edit24.Text);
          if f <> -1 then
          begin
            FileClose(f);
            err := AESGCM.DecryptAndVerifyFromFile(Edit25.Text, Edit24.Text, '',
              Edit26.Text);
          end
          else
            raise Exception.Create('Impossible to create the file ' +
              Edit24.Text);
        end
        else
        begin
          s := Edit25.Text + '.dec';
          err := AESGCM.DecryptAndVerifyFromFile(Edit25.Text, s, '',
            Edit26.Text);
          Edit24.Text := s;
        end;
      end;
    end
    else
      raise Exception.Create('The file ' + Edit26.Text + ' does not exist!');
  end
  else
    raise Exception.Create('The file ' + Edit25.Text + ' does not exist!');
  if err = 0 then
    Panel39.Color := clLime;

end;

procedure TForm5.AESOnChange(Sender: TObject);
begin
  ProgressBar1.Position := AES.Progress;
  Application.ProcessMessages;
end;

procedure TForm5.SPECKOnChange(Sender: TObject);
begin
  ProgressBar2.Position := SPECK.Progress;
  Application.ProcessMessages;
end;

procedure TForm5.SalsaOnChange(Sender: TObject);
begin
  ProgressBar3.Position := Salsa.Progress;
  Application.ProcessMessages;
end;

procedure TForm5.AESMACOnChange(Sender: TObject);
begin
  ProgressBar6.Position := AESMAC.Progress;
  Application.ProcessMessages;
end;

procedure TForm5.AESGCMOnChange(Sender: TObject);
begin
  ProgressBar7.Position := AESGCM.Progress;
  Application.ProcessMessages;
end;

procedure TForm5.SHA2OnChange(Sender: TObject);
begin
  ProgressBar4.Position := SHA2.Progress;
  Application.ProcessMessages;
end;

procedure TForm5.SHA3OnChange(Sender: TObject);
begin
  ProgressBar5.Position := SHA3.Progress;
  Application.ProcessMessages;
end;

procedure TForm5.Blake2BOnChange(Sender: TObject);
begin
  ProgressBar8.Position := Blake2B.Progress;
  Application.ProcessMessages;
end;

procedure TForm5.Button10Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit79.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button11Click(Sender: TObject);
var
  err: Integer;
  filetype: string;
begin
  Memo42.Lines.Clear;
  if Edit79.Text = '' then
    raise Exception.Create('Enter a signature to verify');

  filetype := XAdES.GetFileMimeType(Edit79.Text);

  if filetype = 'application/pdf' then
  begin
    err := PAdES.VerifySignature(Edit79.Text);
    Memo42.Lines.Add(PAdES.VerifyError(err));
    if err <> 0 then
      Memo42.Lines.Add(PAdES.ErrorDetails);
  end
  else if (filetype = 'application/octet-stream') or (filetype = 'pkcs7-mime')
    or (filetype = 'application/pkcs7-mime') then
  begin
    if Edit81.Text = '' then
      raise Exception.Create('Enter the original file path');

    CAdES.PathToOriginalFile := ExtractFilePath(Edit81.Text);
    err := CAdES.VerifySignature(Edit79.Text, Edit81.Text);
    Memo42.Lines.Add(CAdES.VerifyError(err));
    if err <> 0 then
      Memo42.Lines.Add(CAdES.ErrorDetails);

  end
  else if filetype = 'text/xml' then
  begin
    if Edit81.Text = '' then
      raise Exception.Create('Enter the original file path');
    XAdES.PathToOriginalFile := ExtractFilePath(Edit81.Text);
    err := XAdES.VerifySignature(Edit79.Text);
    Memo42.Lines.Add(XAdES.VerifyError(err));
    if err <> 0 then
      Memo42.Lines.Add(XAdES.ErrorDetails);
  end
  else
    raise Exception.Create('Unrecognized signature format');
end;

procedure TForm5.Button12Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit80.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button13Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit81.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button14Click(Sender: TObject);
begin
  if Edit87.Text = '' then
  begin
    Label214.Visible := true;
    raise Exception.Create('Choose a file to save the private key');
  end;
  if Edit88.Text = '' then
  begin
    Label214.Visible := true;
    raise Exception.Create('Choose a file to save the certificate');
  end;

  if ComboBox35.ItemIndex = -1 then
  begin
    Label214.Visible := true;
    raise Exception.Create('Choose a signature algorithm');
  end;

  if ComboBox36.ItemIndex = -1 then
  begin
    Label214.Visible := true;
    raise Exception.Create('Choose a key length');
  end;

  if Edit85.Text = '' then
  begin
    Label214.Visible := true;
    raise Exception.Create('Enter a common name');
  end;

  X509CSR.KeyFilePath := Edit87.Text;
  X509CSR.CSrFilePath := Edit88.Text;
  if ComboBox35.ItemIndex = 0 then
  begin
    if ComboBox34.ItemIndex = 0 then
    begin
      X509CSR.signatureAlgorithm := TSignAlgo.sa_sha256rsa;
      X509CSR.hashFunction := TX509HashFunction.sha256;
    end
    else if ComboBox34.ItemIndex = 1 then
    begin
      X509CSR.signatureAlgorithm := TSignAlgo.sa_sha384rsa;
      X509CSR.hashFunction := TX509HashFunction.sha384;
    end
    else if ComboBox34.ItemIndex = 2 then
    begin
      X509CSR.signatureAlgorithm := TSignAlgo.sa_sha512rsa;
      X509CSR.hashFunction := TX509HashFunction.sha512;
    end
    else
      raise Exception.Create('Choose a hash function');
    if ComboBox36.ItemIndex = 0 then
      X509CSR.BitSizeEncryptionAlgorithm := 2048
    else
      X509CSR.BitSizeEncryptionAlgorithm := 4096;
  end
  else if ComboBox35.ItemIndex = 1 then
  begin
    X509CSR.signatureAlgorithm := TSignAlgo.sa_rsapss;
    if ComboBox34.ItemIndex = -1 then
      raise Exception.Create('Choose a hash function');
    X509CSR.hashFunction := TX509HashFunction(ComboBox34.ItemIndex + 1);
    if ComboBox36.ItemIndex = 0 then
      X509CSR.BitSizeEncryptionAlgorithm := 2048
    else
      X509CSR.BitSizeEncryptionAlgorithm := 4096;
  end
  else
  begin
    if ComboBox36.ItemIndex = 0 then
    begin
      X509CSR.signatureAlgorithm := TSignAlgo.sa_sha256ec;
      X509CSR.hashFunction := TX509HashFunction.sha256;
      X509CSR.BitSizeEncryptionAlgorithm := 256;
    end
    else if ComboBox36.ItemIndex = 1 then
    begin
      X509CSR.signatureAlgorithm := TSignAlgo.sa_sha384ec;
      X509CSR.hashFunction := TX509HashFunction.sha384;
      X509CSR.BitSizeEncryptionAlgorithm := 384;
    end
    else if ComboBox36.ItemIndex = 2 then
    begin
      X509CSR.signatureAlgorithm := TSignAlgo.sa_sha512ec;
      X509CSR.hashFunction := TX509HashFunction.sha512;
      X509CSR.BitSizeEncryptionAlgorithm := 521;
    end;

  end;
  X509CSR.countryName := Edit89.Text;
  X509CSR.stateName := Edit86.Text;
  X509CSR.localityName := Edit82.Text;
  X509CSR.OrganizationName := Edit83.Text;
  X509CSR.OrganizationUnitName := Edit84.Text;
  X509CSR.commonName := Edit85.Text;

  try
    EnableButtonsCSR(false);
    Label214.Visible := false;
    Label215.Visible := false;
    Label216.Visible := true;
    Application.ProcessMessages;

    X509CSR.Unicode := yesUni;
    X509CSR.Generate;

    EnableButtonsCSR(true);
    Application.ProcessMessages;
    Label216.Visible := false;
    Label215.Caption := 'CSR successfully created!';
    Label215.Visible := true;
  except
    Label215.Caption := 'Generation failed, please try again';
    Label215.Visible := true;
  end;
end;

procedure TForm5.Button15Click(Sender: TObject);
begin
  SaveDialog1.FileName := 'mykey.key';
  if SaveDialog1.Execute() then
    Edit87.Text := SaveDialog1.FileName;
end;

procedure TForm5.Button16Click(Sender: TObject);
begin
  SaveDialog1.FileName := 'mycsr.csr';
  if SaveDialog1.Execute() then
    Edit88.Text := SaveDialog1.FileName;
end;

procedure TForm5.Button17Click(Sender: TObject);
begin
  SaveDialog1.FileName := 'mycert.crt';
  if SaveDialog1.Execute() then
    Edit90.Text := SaveDialog1.FileName;
end;

procedure TForm5.Button18Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit91.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button19Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit92.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button1Click(Sender: TObject);
begin
  SaveDialog1.FileName := 'mykey.key';
  if SaveDialog1.Execute() then
    Edit37.Text := SaveDialog1.FileName;
end;

procedure TForm5.Button20Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit93.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button21Click(Sender: TObject);
begin
  if Edit93.Text = '' then
  begin
    Label230.Visible := true;
    raise Exception.Create('Choose a CSR file');
  end;
  if Edit92.Text = '' then
  begin
    Label230.Visible := true;
    raise Exception.Create('Choose a private key file');
  end;
  if Edit91.Text = '' then
  begin
    Label230.Visible := true;
    raise Exception.Create('Choose a certificate file');
  end;
  if Edit90.Text = '' then
  begin
    Label230.Visible := true;
    raise Exception.Create('Choose a file to save the output certificate');
  end;

  try
    Label230.Visible := false;
    Label231.Visible := false;
    Label232.Visible := true;

    X509Cert.CrtFilePath := Edit91.Text;
    X509Cert.KeyFilePath := Edit92.Text;

    Application.ProcessMessages;
    X509Cert.SignCSR(Edit93.Text, Edit90.Text);

    Application.ProcessMessages;
    Label232.Visible := false;
    Label231.Caption := 'CSR successfully signed!';
    Label231.Visible := true;
  except
    EnableButtonsCSR(true);
    Application.ProcessMessages;
    Label232.Visible := false;
    Label231.Caption := 'Signature failed, please try again';
    Label231.Visible := true;
  end;
end;

procedure TForm5.Button22Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit95.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button2Click(Sender: TObject);
begin
  SaveDialog1.FileName := 'mycert.crt';
  if SaveDialog1.Execute() then
    Edit38.Text := SaveDialog1.FileName;
end;

procedure TForm5.EnableButtons(bfOn: Boolean);
begin
  Button1.Enabled := bfOn;
  Button2.Enabled := bfOn;
  Button3.Enabled := bfOn;
  Edit37.Enabled := bfOn;
  Edit38.Enabled := bfOn;
  Edit39.Enabled := bfOn;
  Edit40.Enabled := bfOn;
  Edit41.Enabled := bfOn;
  Edit42.Enabled := bfOn;
  Edit43.Enabled := bfOn;
  Edit44.Enabled := bfOn;
  ComboBox31.Enabled := bfOn;
  ComboBox32.Enabled := bfOn;
  ComboBox28.Enabled := bfOn;
end;

procedure TForm5.EnableButtonsCSR(bfOn: Boolean);
begin
  Button15.Enabled := bfOn;
  Button16.Enabled := bfOn;
  Button14.Enabled := bfOn;
  Edit82.Enabled := bfOn;
  Edit83.Enabled := bfOn;
  Edit84.Enabled := bfOn;
  Edit85.Enabled := bfOn;
  Edit86.Enabled := bfOn;
  Edit87.Enabled := bfOn;
  Edit88.Enabled := bfOn;
  Edit89.Enabled := bfOn;
  ComboBox34.Enabled := bfOn;
  ComboBox35.Enabled := bfOn;
  ComboBox36.Enabled := bfOn;
end;

procedure TForm5.Button3Click(Sender: TObject);
begin
  X509Cert.RootCAPath := '..\\..\\RootCA\\';
  X509Cert.Unicode := yesUni;
  if Edit37.Text = '' then
  begin
    Label174.Visible := true;
    raise Exception.Create('Choose a file to save the private key');
  end;
  if Edit38.Text = '' then
  begin
    Label174.Visible := true;
    raise Exception.Create('Choose a file to save the certificate');
  end;

  if ComboBox31.ItemIndex = -1 then
  begin
    Label174.Visible := true;
    raise Exception.Create('Choose a signature algorithm');
  end;

  if ComboBox32.ItemIndex = -1 then
  begin
    Label174.Visible := true;
    raise Exception.Create('Choose a key length');
  end;

  if Edit44.Text = '' then
  begin
    Label174.Visible := true;
    raise Exception.Create('Enter a common name');
  end;

  X509Cert.KeyFilePath := Edit37.Text;
  X509Cert.CrtFilePath := Edit38.Text;
  if ComboBox31.ItemIndex = 0 then
  begin
    if ComboBox28.ItemIndex = 0 then
    begin
      X509Cert.signatureAlgorithm := TSignAlgo.sa_sha256rsa;
      X509Cert.hashFunction := TX509HashFunction.sha256;
    end
    else if ComboBox28.ItemIndex = 1 then
    begin
      X509Cert.signatureAlgorithm := TSignAlgo.sa_sha384rsa;
      X509Cert.hashFunction := TX509HashFunction.sha384;
    end
    else if ComboBox28.ItemIndex = 2 then
    begin
      X509Cert.signatureAlgorithm := TSignAlgo.sa_sha512rsa;
      X509Cert.hashFunction := TX509HashFunction.sha512;
    end
    else
      raise Exception.Create('Choose a hash function');
    if ComboBox32.ItemIndex = 0 then
      X509Cert.BitSizeEncryptionAlgorithm := 2048
    else
      X509Cert.BitSizeEncryptionAlgorithm := 4096;
  end
  else if ComboBox31.ItemIndex = 1 then
  begin
    X509Cert.signatureAlgorithm := TSignAlgo.sa_rsapss;
    if ComboBox28.ItemIndex = -1 then
      raise Exception.Create('Choose a hash function');
    X509Cert.hashFunction := TX509HashFunction(ComboBox28.ItemIndex + 1);
    if ComboBox32.ItemIndex = 0 then
      X509Cert.BitSizeEncryptionAlgorithm := 2048
    else
      X509Cert.BitSizeEncryptionAlgorithm := 4096;
  end
  else
  begin
    if ComboBox32.ItemIndex = 0 then
    begin
      X509Cert.signatureAlgorithm := TSignAlgo.sa_sha256ec;
      X509Cert.hashFunction := TX509HashFunction.sha256;
      X509Cert.BitSizeEncryptionAlgorithm := 256;
    end
    else if ComboBox32.ItemIndex = 1 then
    begin
      X509Cert.signatureAlgorithm := TSignAlgo.sa_sha384ec;
      X509Cert.hashFunction := TX509HashFunction.sha384;
      X509Cert.BitSizeEncryptionAlgorithm := 384;
    end
    else if ComboBox32.ItemIndex = 2 then
    begin
      X509Cert.signatureAlgorithm := TSignAlgo.sa_sha512ec;
      X509Cert.hashFunction := TX509HashFunction.sha512;
      X509Cert.BitSizeEncryptionAlgorithm := 521;
    end;

  end;
  X509Cert.countryName := Edit39.Text;
  X509Cert.stateName := Edit40.Text;
  X509Cert.localityName := Edit41.Text;
  X509Cert.OrganizationName := Edit42.Text;
  X509Cert.OrganizationUnitName := Edit43.Text;
  X509Cert.commonName := Edit44.Text;
  X509Cert.AltName1 := Edit50.Text;
  X509Cert.AltName2 := Edit49.Text;
  X509Cert.AltName3 := Edit48.Text;
  X509Cert.AltName4 := Edit47.Text;
  X509Cert.AltName5 := Edit46.Text;
  X509Cert.AltName6 := Edit45.Text;
  X509Cert.isCA := CheckBox1.Checked;

  try
    EnableButtons(false);
    Label174.Visible := false;
    Label175.Visible := false;
    Label176.Visible := true;
    Application.ProcessMessages;

    X509Cert.GenerateSelfSigned;

    EnableButtons(true);
    Application.ProcessMessages;
    Label176.Visible := false;
    Label175.Caption := 'Certificate successfully created!';
    Label175.Visible := true;
  except
    Label175.Caption := 'Generation failed, please try again';
    Label175.Visible := true;
  end;

end;

procedure TForm5.Button4Click(Sender: TObject);
begin

  if OpenDialog1.Execute then
  begin
    if OpenDialog1.FileName = '' then
      ShowMessage('Enter a certificate file to parse');

    Edit51.Text := OpenDialog1.FileName;

    X509Cert.RootCAPath := '..\\..\\RootCA\\';
    X509Cert.CrtFilePath := OpenDialog1.FileName;
    X509Cert.Unicode := yesUni;
    X509Cert.Decode;

    Edit53.Text := X509Cert.version;

    Edit52.Text := X509Cert.serialNumber;

    Edit54.Text := TabSignAlgo[Integer(X509Cert.signatureAlgorithm)];

    Edit55.Text := X509Cert.notBefore;

    Edit56.Text := X509Cert.notAfter;

    Edit57.Text := X509Cert.IssuercountryName;

    Edit59.Text := X509Cert.IssuerstateName;

    Edit61.Text := X509Cert.IssuerlocalityName;

    Edit63.Text := X509Cert.IssuerOrganizationName;

    Edit65.Text := X509Cert.IssuerOrganizationUnitName;

    Edit73.Text := X509Cert.IssuercommonName;

    Edit58.Text := X509Cert.countryName;

    Edit60.Text := X509Cert.stateName;

    Edit62.Text := X509Cert.localityName;

    Edit64.Text := X509Cert.OrganizationName;

    Edit66.Text := X509Cert.OrganizationUnitName;

    Edit74.Text := X509Cert.commonName;

    Edit67.Text := X509Cert.AltName1 + ' ';

    Edit67.Text := Edit67.Text + X509Cert.AltName2 + ' ';

    Edit67.Text := Edit67.Text + X509Cert.AltName3 + ' ';

    Edit67.Text := Edit67.Text + X509Cert.AltName4 + ' ';

    Edit67.Text := Edit67.Text + X509Cert.AltName5 + ' ';

    Edit67.Text := Edit67.Text + X509Cert.AltName6 + ' ';

    Edit68.Text := X509Cert.EncryptionAlgorithm;
    Edit69.Text := inttostr(X509Cert.BitSizeEncryptionAlgorithm) + ' bits';

    Edit70.Text := X509Cert.Modulus;

    Edit71.Text := X509Cert.ecCurve;

    Edit72.Text := X509Cert.PublicKey;

    Label201.Caption := X509Cert.IsSignatureValid;
    if (X509Cert.IsSignatureValid = 'Valid') or
      (X509Cert.IsSignatureValid = 'Valid self-signed certificate') then
      Label201.Font.Color := clGreen
    else
      Label201.Font.Color := clRed;
  end;
end;

procedure TForm5.Button5Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit75.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button6Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit76.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button7Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit77.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button8Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
    Edit78.Text := OpenDialog1.FileName;
end;

procedure TForm5.Button9Click(Sender: TObject);
var
  FileToSign: string;
  OutputFilePath, keyfileS, CertFileS, pfxfileS: string;
  pkcs12: Boolean;
  pkcs11: Boolean;
  PKCS11Class: TPKCS11;
  DLLPath, PIN: string;
begin
  Label206.Visible := false;
  pkcs11 := false;
  pkcs12 := false;

  if ((Edit75.Text <> '') and (Edit76.Text <> '')) or (Edit80.Text <> '') or
    (Edit95.Text <> '') then
  begin
    if (Edit75.Text <> '') and (Edit76.Text <> '') then
    begin
      keyfileS := Edit75.Text;
      CertFileS := Edit76.Text;
      pkcs12 := false;
      pkcs11 := false;
    end
    else if (Edit80.Text <> '') then
    begin
      pkcs12 := true;
      pfxfileS := Edit80.Text;
      pkcs11 := false;
    end
    else
    begin
      DLLPath := Edit95.Text;
      PIN := Edit97.Text;
      pkcs11 := true;
      pkcs12 := false;
    end;
  end
  else
  begin
    if Edit75.Text = '' then
      raise Exception.Create('Enter a key file path');
    if Edit76.Text = '' then
      raise Exception.Create('Enter a certificate file path');
  end;

  if Edit77.Text <> '' then
    FileToSign := Edit77.Text
  else
    raise Exception.Create('Choose a file to sign');

  if Edit78.Text <> '' then
    OutputFilePath := Edit78.Text
  else
    raise Exception.Create('Choose an output file path');

  if RadioButton4.Checked then
  begin
    Label206.Visible := false;

    if (pkcs12 = false) and (pkcs11 = false) then
    begin
      XAdES.KeyFilePath := keyfileS;
      XAdES.CertFilePath := CertFileS;
      XAdES.PKCS11Param.isToken := false;
    end
    else if (pkcs12 = true) and (pkcs11 = false) then
    begin
      XAdES.PKCS11Param.isToken := false;
      FromPFXAskPassword(Self, pfxfileS, 0);
    end
    else if pkcs11 = true then
    begin
      XAdES.PKCS11Param.isToken := true;
      XAdES.PKCS11Param.SlotIndex := 0;
      PKCS11Class := TPKCS11.Create(DLLPath);
      try
        XAdES.PKCS11Param.CertIndex := PKCS11Class.CertificatesIndex[0];
      finally
        PKCS11Class.Free;
      end;
      XAdES.PKCS11Param.DLLPath := DLLPath;
      XAdES.PKCS11Param.PIN := PIN;
    end;

    if RadioButton1.Checked then
      XAdES.Packaging := Detached
    else if RadioButton2.Checked then
      XAdES.Packaging := Enveloping
    else if RadioButton3.Checked then
      XAdES.Packaging := Enveloped
    else
      raise Exception.Create
        ('Choose a format: detached, enveloped or enveloping');

    XAdES.PathToOriginalFile := ExtractFilePath(FileToSign);
    XAdES.GenerateSignature(FileToSign, OutputFilePath);
    Label206.Visible := true;
  end
  else if RadioButton5.Checked then
  begin
    Label206.Visible := false;

    if (pkcs12 = false) and (pkcs11 = false) then
    begin
      CAdES.KeyFilePath := keyfileS;
      CAdES.CertFilePath := CertFileS;
      CAdES.PKCS11Param.isToken := false;
    end
    else if (pkcs12 = true) and (pkcs11 = false) then
    begin
      CAdES.PKCS11Param.isToken := false;
      FromPFXAskPassword(Self, pfxfileS, 1);
    end
    else if pkcs11 = true then
    begin
      CAdES.PKCS11Param.isToken := true;
      CAdES.PKCS11Param.SlotIndex := 0;
      PKCS11Class := TPKCS11.Create(DLLPath);
      try
        CAdES.PKCS11Param.CertIndex := PKCS11Class.CertificatesIndex[0];
      finally
        PKCS11Class.Free;
      end;
      CAdES.PKCS11Param.DLLPath := DLLPath;
      CAdES.PKCS11Param.PIN := PIN;
    end;

    if RadioButton1.Checked then
      CAdES.Packaging := Detached
    else if RadioButton2.Checked then
      CAdES.Packaging := Enveloping
    else
      raise Exception.Create('Choose a format: detached or enveloping');
    CAdES.PathToOriginalFile := ExtractFilePath(FileToSign);
    CAdES.GenerateSignature(FileToSign, OutputFilePath, '');
    Label206.Visible := true;
  end
  else if RadioButton6.Checked then
  begin
    Label206.Visible := false;
    if (pkcs12 = false) and (pkcs11 = false) then
    begin
      PAdES.KeyFilePath := keyfileS;
      PAdES.CertFilePath := CertFileS;
      PAdES.PKCS11Param.isToken := false;
    end
    else if (pkcs12 = true) and (pkcs11 = false) then
    begin
      PAdES.PKCS11Param.isToken := false;
      FromPFXAskPassword(Self, pfxfileS, 2);
    end
    else if pkcs11 = true then
    begin
      PAdES.PKCS11Param.isToken := true;
      PAdES.PKCS11Param.SlotIndex := 0;
      PKCS11Class := TPKCS11.Create(DLLPath);
      try
        PAdES.PKCS11Param.CertIndex := PKCS11Class.CertificatesIndex[0];
      finally
        PKCS11Class.Free;
      end;
      PAdES.PKCS11Param.DLLPath := DLLPath;
      PAdES.PKCS11Param.PIN := PIN;
    end;

    PAdES.PathToOriginalFile := ExtractFilePath(FileToSign);
    PAdES.GenerateSignature(FileToSign, OutputFilePath);
    Label206.Visible := true;
  end
  else
    raise Exception.Create('Choose a signature format');

end;

procedure TForm5.RadioButton4Click(Sender: TObject);
begin
  if RadioButton4.Checked then
  begin
    RadioButton1.Enabled := true;
    RadioButton2.Enabled := true;
    RadioButton3.Enabled := true;
  end;
end;

procedure TForm5.RadioButton5Click(Sender: TObject);
begin
  if RadioButton5.Checked then
  begin
    RadioButton1.Enabled := true;
    RadioButton2.Enabled := true;
    RadioButton3.Enabled := false;
  end;
end;

procedure TForm5.RadioButton6Click(Sender: TObject);
begin
  if RadioButton6.Checked then
  begin
    RadioButton1.Enabled := false;
    RadioButton2.Enabled := false;
    RadioButton3.Enabled := true;
  end;
end;

procedure TForm5.RIPEMD160OnChange(Sender: TObject);
begin
  ProgressBar9.Position := RIPEMD160.Progress;
  Application.ProcessMessages;
end;

end.
